////////////////////////////////////////////////////////////////////////////////
//
// ProofTool -------------------------------------------------------------------
//
// File: ./command/execcontext.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _EXECCONTEXT_H_
#define _EXECCONTEXT_H_

class GraphicSystem;
class GraphicWindow;
namespace ProofLib
{
  class ProofDatabase;
  class NodeDatabase;
  class SymbolTable;
}
class CommandProcessor;
class CommandConsole;

class ExecContext
{
public:
  virtual GraphicSystem* GetGraphicSystem() = 0;
  virtual void SetProofDatabase( ProofLib::ProofDatabase *db ) = 0;
  virtual ProofLib::ProofDatabase* GetProofDatabase() const = 0;
  virtual ProofLib::NodeDatabase* GetNodeDatabase() const = 0;
  virtual ProofLib::SymbolTable* GetSymbolTable() const = 0;
  virtual void SetProofWindow( GraphicWindow *wnd ) = 0;
  virtual GraphicWindow* GetProofWindow() const = 0;
  virtual CommandProcessor* GetCommandProcessor() = 0;
  virtual CommandConsole* GetConsole() const = 0;
  virtual void SetConsole( CommandConsole* console ) = 0;
};

ExecContext* GetContext();


#endif

