////////////////////////////////////////////////////////////////////////////////
//
// ProofTool -------------------------------------------------------------------
//
// File: ./command/guile/commandimpl.cpp
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#include <sstream>

#include "util/myassert.h"
#include "util/exceptions.h"
#include "chars/latexchars.h"

#include "commandimpl.h"

////////////////////////////////////////////////////////////////////////////////

#if 0
CommandImpl::CommandImpl( ExecContext *ctxt )
{
  m_ctxt = ctxt;
}

SLObject* CommandImpl::Execute( SLObject *args )
{
  CheckAndSetParameter( args );
  return Execute_();
}

void CommandImpl::SetObjectParam( SLObject **store, SLObject* obj )
{
  *store = obj;
}

void CommandImpl::SetListParam( SLList **store, SLObject* obj )
{
  *store = LispProcessor::EnsureList( obj, GetCommandName() );
}

void CommandImpl::SetSymbolParam( SLSymbol **store, SLObject* obj )
{
  *store = LispProcessor::EnsureSymbol( obj, GetCommandName() );
}


void CommandImpl::SetStringParam( SLString **store, SLObject* obj )
{
  *store = LispProcessor::EnsureString( obj, GetCommandName() );
}

void CommandImpl::SetIntegerParam( SLInteger **store, SLObject* obj )
{
  *store = LispProcessor::EnsureInteger( obj, GetCommandName() );
}
#endif

SCM CommandImpl::ToSCM( const USTRING& str )
{
  std::string scm_str;

  LatexConvertor.GetLatex( str, scm_str );

  return scm_makfrom0str( scm_str.c_str() );
}

USTRING CommandImpl::ToUString( const char* str )
{
  USTRING dest;

  LatexConvertor.GetUnicode( str, dest );

  return dest;
}

void CommandImpl::CheckAndSetParameter( SCM args )
{
  int arg_num = 0;
  
  const t_CMD_arg_list *arg_def = GetCmdArgList();

  while( arg_def != NULL && arg_def[arg_num].name != NULL )
  {
#if 0
using namespace std;
cout << GetCommandName() << " : " << arg_num << endl;
#endif
    ASSERT( arg_def[arg_num].num == arg_num );

#if 0
    scm_write( args, scm_current_output_port() );
    scm_puts( "\n", scm_current_output_port() );
#endif

    if( scm_null_p( args ) == SCM_BOOL_T )
      scm_error_num_args_subr( GetCommandName() );

    ASSERT( scm_list_p( args ) == SCM_BOOL_T );

    SCM arg = SCM_CAR( args );

#if 0
    scm_write( arg, scm_current_output_port() );
    scm_puts( "\n", scm_current_output_port() );
#endif

    arg_def[arg_num].setfunc( this, arg, arg_num+1 );

    args = SCM_CDR( args );
    arg_num++;
  }

  if( scm_null_p( args ) != SCM_BOOL_T )
    scm_error_num_args_subr( GetCommandName() );
}

void CommandImpl::HandleException( Exception *e, const char *func )
{
  ASSERT( e != NULL );

  std::ostringstream ostr;

  e->Print( ostr );
  delete e;

  scm_error( scm_misc_error_key, func,
             ostr.str().c_str(), SCM_BOOL_F, SCM_BOOL_F );
}

