////////////////////////////////////////////////////////////////////////////////
//
// ProofTool -------------------------------------------------------------------
//
// File: ./command/guile/guilecommandcall.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _GUILECOMMANDCALL_H_
#define _GUILECOMMANDCALL_H_

#include <stack>
#include <libguile.h>

#include "command/commandprocessor.h"

class GuileCommandCallArg : public CommandCallArg
{
private:
  DrawItem              *m_draw_item;

public:
  GuileCommandCallArg( DrawItem *item, DrawPoint *pt );

  SCM MakeSCM() const;
};

class GuileCommandCall : public CommandCall
{
private:
  std::stack<GuileCommandCallArg*> m_apply_stack;

  SCM                    m_cmd;
  SCM                    m_result;
  TCondition            *m_cond;
  std::string            m_response_str;

  GuileCommandCall( const GuileCommandCall &other ) {}

public:
  GuileCommandCall( bool show_in_console = false );
  virtual ~GuileCommandCall();

  void SetSCM( SCM cmd );
  SCM GetCallSCM();

  virtual void SetResponse( const char *str ) { m_response_str = str; }
  virtual const std::string& GetResponse() const { return m_response_str; }

  virtual CommandCall* Apply() const;
  virtual CommandCall* Apply( CommandCallArg *arg ) const;

  virtual CommandCallArg* NewArgument( DrawItem *item,
                                       DrawPoint *pt ) const;

  void SetCondition( TCondition *cond ) { m_cond = cond; }
  TCondition* GetCondition() const { return m_cond; }

  virtual GraphicMenu* GetResult() const;

  void SetResultSCM( SCM result );

protected:
  void SetSCMApply( SCM args );

};

#endif
