////////////////////////////////////////////////////////////////////////////////
//
// ProofTool -------------------------------------------------------------------
//
// File: ./graphic/acceldb.cpp
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#include "acceldb.h"

CommandCall*
AccelDB::LookupCommand( unsigned int key, unsigned int mods ) const
{
  const_iterator i = find( CalcLookupValue( key, mods ) );

  if( i == end() )
    return NULL;

  return i->second;
}

void AccelDB::AddCommand( unsigned int key, unsigned int mods,
                                CommandCall *cmd )
{
  (*this)[CalcLookupValue( key, mods )] = cmd;
}

inline unsigned int AccelDB::CalcLookupValue( unsigned int key, unsigned int mods )
{
  return (key << 1) + mods;
}
