////////////////////////////////////////////////////////////////////////////////
//
// ProofTool -------------------------------------------------------------------
//
// File: ./graphic/acceldb.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _ACCELDB_H_
#define _ACCELDB_H_

#include "util/hash.h"

#include "command/commandprocessor.h"


#define ACCEL_MODIFIER_SHIFT          (1<<0)
#define ACCEL_MODIFIER_CTRL           (1<<1)
#define ACCEL_MODIFIER_ALT            (1<<2)
#define ACCEL_MODIFIER_META           (1<<3)


class AccelDB : protected stlhash::hash_map< unsigned int, CommandCall* >
{
public:
  CommandCall* LookupCommand( unsigned int key, unsigned int mods ) const; 
  void AddCommand( unsigned int key, unsigned int mods, CommandCall *c );

protected:
  static unsigned int CalcLookupValue( unsigned int key, unsigned int mods );
};

#endif

