////////////////////////////////////////////////////////////////////////////////
//
// ProofTool -------------------------------------------------------------------
//
// File: ./graphic/buttondb.cpp
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#include "buttondb.h"

CommandCall*
ButtonDB::LookupCommand( unsigned int button, unsigned int mods ) const
{
  button += BUTTONDB_NUM_SPEC_BUTTONS;

  size_t index = CalcLookupValue( button, mods );

  if( index >= size() )
    return NULL;

  return (*this)[CalcLookupValue( button, mods )];
}

void ButtonDB::AddCommand( unsigned int button, unsigned int mods,
                                CommandCall *cmd )
{
  button += BUTTONDB_NUM_SPEC_BUTTONS;

  size_t index = CalcLookupValue( button, mods );

  if( size() <= index )
    resize( index+1, NULL );

  (*this)[index] = cmd;
}

inline unsigned int ButtonDB::CalcLookupValue( unsigned int button, unsigned int mods )
{
  return (button << 2) + mods;
}
