////////////////////////////////////////////////////////////////////////////////
//
// ProofTool -------------------------------------------------------------------
//
// File: ./graphic/proofsheetnotificant.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _PROOFSHEETNOTIFICANT_H_
#define _PROOFSHEETNOTIFICANT_H_

#include <set>

class ProofSheetNotificant
{
public:
  virtual void ChangeProofEvent( ProofLib::Proof *proof_new,
                                 ProofLib::Proof *proof_old ) {}
  virtual void ResizeProofSheetEvent() {}
};

class ProofSheetNotificantList : public std::set<ProofSheetNotificant*>
{
public:
  void FireNewProof( ProofLib::Proof *proof_new, ProofLib::Proof *proof_old )
  {
    for( const_iterator i = begin(); i != end(); i++ )
      (*i)->ChangeProofEvent( proof_new, proof_old );
  }
  void FireResize()
  {
    for( const_iterator i = begin(); i != end(); i++ )
      (*i)->ResizeProofSheetEvent();
  }
};

#endif
