////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: chars/latexchars.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _LATEXCHARS_H_
#define _LATEXCHARS_H_

#include <string>

#include "util/hash.h"
#include "chars.h"

class LatexToUnicode :
  public stlhash::hash_map<const char*, UCHAR, stlhash::hash<const char*>, eqstr>
{
};

class UnicodeToLatex :
  public stlhash::hash_map<UCHAR, const char*>
{
};

class LatexChars
{
public:
  LatexChars();

  void AddTranslation( const char *l, UCHAR u );

  UCHAR GetUnicode( const char* str );
  const char *GetLatex( UCHAR code );

  //void GetUnicode( const std::string& src, USTRING &dest );
  void GetUnicode( const char* src, USTRING &dest );
  void GetLatex( const USTRING& src, std::string &dest );
  //void GetLatex( const UCHAR* src, std::string &dest );
  USTRING& KnownLatexSymbolsToUnicode( USTRING &to_change );

protected:
  LatexToUnicode         m_ltou;
  UnicodeToLatex         m_utol;
};

extern LatexChars LatexConvertor;

#endif
