////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: chars/type1chars.cpp
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifdef DEBUG
#include <iostream>
using namespace std;
#endif

#include "type1chars.h"

Type1Chars Type1Convertor;

#define TYPE1CHAR( l, u )  AddTranslation( l, u )

#if 0
#define CHAR_NOTIN                      CHAR(0x2209U)
#define CHAR_PROD                       CHAR(0x220FU)
#define CHAR_SUM                        CHAR(0x2211U)
#define CHAR_MINUS                      CHAR(0x2212U)
#define CHAR_ANG                        CHAR(0x2220U)
#define CHAR_THERE4                     CHAR(0x2234U)
#define CHAR_CONG                       CHAR(0x2245U)
#define CHAR_NE                         CHAR(0x2260U)
#define CHAR_NSUB                       CHAR(0x2284U)
#endif
Type1Chars::Type1Chars()
{
// cmmi8.pfb
  TYPE1CHAR( "Gamma", CHAR_CAPITALGAMMA );
  TYPE1CHAR( "Delta", CHAR_CAPITALDELTA );
  TYPE1CHAR( "Theta", CHAR_CAPITALTHETA );
  TYPE1CHAR( "Lambda", CHAR_CAPITALLAMBDA );
  TYPE1CHAR( "Xi", CHAR_CAPITALXI );
  TYPE1CHAR( "Pi", CHAR_CAPITALPI );
  TYPE1CHAR( "Sigma", CHAR_CAPITALSIGMA );
  //TYPE1CHAR( "Upsilon", CHAR_ );
  TYPE1CHAR( "Phi", CHAR_CAPITALPHI );
  TYPE1CHAR( "Psi", CHAR_CAPITALPSI );
  TYPE1CHAR( "Omega", CHAR_CAPITALOMEGA );
  TYPE1CHAR( "alpha", CHAR_ALPHA );
  TYPE1CHAR( "beta", CHAR_BETA );
  TYPE1CHAR( "gamma", CHAR_GAMMA );
  TYPE1CHAR( "delta", CHAR_DELTA );
  TYPE1CHAR( "epsilon1", CHAR_CURLYEPSILON );
  TYPE1CHAR( "zeta", CHAR_ZETA );
  TYPE1CHAR( "eta", CHAR_ETA );
  TYPE1CHAR( "theta", CHAR_THETA );
  TYPE1CHAR( "iota", CHAR_IOTA );
  TYPE1CHAR( "kappa", CHAR_KAPPA );
  TYPE1CHAR( "lambda", CHAR_LAMBDA );
  TYPE1CHAR( "mu", CHAR_MU );
  TYPE1CHAR( "nu", CHAR_NU );
  TYPE1CHAR( "xi", CHAR_XI );
  TYPE1CHAR( "pi", CHAR_PI );
  TYPE1CHAR( "rho", CHAR_RHO );
  TYPE1CHAR( "sigma1", CHAR_FINALSIGMA );
  TYPE1CHAR( "sigma", CHAR_SIGMA );
  TYPE1CHAR( "tau", CHAR_TAU );
  TYPE1CHAR( "upsilon", CHAR_UPSILON );
  TYPE1CHAR( "phi1", CHAR_CURLYPHI );
  TYPE1CHAR( "chi", CHAR_CHI );
  TYPE1CHAR( "psi", CHAR_PSI );
  TYPE1CHAR( "omega", CHAR_OMEGA );
  TYPE1CHAR( "phi", CHAR_PHI );
  TYPE1CHAR( "epsilon", CHAR_EPSILON );
  TYPE1CHAR( "theta1", CHAR_CURLYTHETA );
  TYPE1CHAR( "pi1", CHAR_CURLYPI );
  TYPE1CHAR( "rho1", CHAR_CURLYRHO );

#if 0
  TYPE1CHAR( "arrowlefttophalf", CHAR_ );
  TYPE1CHAR( "arrowleftbothalf", CHAR_ );
  TYPE1CHAR( "arrowrighttophalf", CHAR_ );
  TYPE1CHAR( "arrowrightbothalf", CHAR_ );
  TYPE1CHAR( "arrowhookleft", CHAR_ );
  TYPE1CHAR( "arrowhookright", CHAR_ );
  TYPE1CHAR( "triangleright", CHAR_ );
  TYPE1CHAR( "triangleleft", CHAR_ );
  TYPE1CHAR( "zerooldstyle", CHAR_ );
  TYPE1CHAR( "oneoldstyle", CHAR_ );
  TYPE1CHAR( "twooldstyle", CHAR_ );
  TYPE1CHAR( "threeoldstyle", CHAR_ );
  TYPE1CHAR( "fouroldstyle", CHAR_ );
  TYPE1CHAR( "fiveoldstyle", CHAR_ );
  TYPE1CHAR( "sixoldstyle", CHAR_ );
  TYPE1CHAR( "sevenoldstyle", CHAR_ );
  TYPE1CHAR( "eightoldstyle", CHAR_ );
  TYPE1CHAR( "nineoldstyle", CHAR_ );
#endif
  TYPE1CHAR( "period", '.' );
  TYPE1CHAR( "comma", ',' );
  TYPE1CHAR( "less", '<' );
  TYPE1CHAR( "slash", '/' );
  TYPE1CHAR( "greater", '>' );
#if 0
  TYPE1CHAR( "star", CHAR_ );
#endif
  TYPE1CHAR( "partialdiff", CHAR_PART );
  TYPE1CHAR( "A", 'A' );
  TYPE1CHAR( "B", 'B' );
  TYPE1CHAR( "C", 'C' );
  TYPE1CHAR( "D", 'D' );
  TYPE1CHAR( "E", 'E' );
  TYPE1CHAR( "F", 'F' );
  TYPE1CHAR( "G", 'G' );
  TYPE1CHAR( "H", 'H' );
  TYPE1CHAR( "I", 'I' );
  TYPE1CHAR( "J", 'J' );
  TYPE1CHAR( "K", 'K' );
  TYPE1CHAR( "L", 'L' );
  TYPE1CHAR( "M", 'M' );
  TYPE1CHAR( "N", 'N' );
  TYPE1CHAR( "O", 'O' );
  TYPE1CHAR( "P", 'P' );
  TYPE1CHAR( "Q", 'Q' );
  TYPE1CHAR( "R", 'R' );
  TYPE1CHAR( "S", 'S' );
  TYPE1CHAR( "T", 'T' );
  TYPE1CHAR( "U", 'U' );
  TYPE1CHAR( "V", 'V' );
  TYPE1CHAR( "W", 'W' );
  TYPE1CHAR( "X", 'X' );
  TYPE1CHAR( "Y", 'Y' );
  TYPE1CHAR( "Z", 'Z' );
#if 0
  TYPE1CHAR( "flat", CHAR_ );
  TYPE1CHAR( "natural", CHAR_ );
  TYPE1CHAR( "sharp", CHAR_ );
  TYPE1CHAR( "slurbelow", CHAR_ );
  TYPE1CHAR( "slurabove", CHAR_ );
  TYPE1CHAR( "lscript", CHAR_ );
#endif
  TYPE1CHAR( "a", 'a' );
  TYPE1CHAR( "b", 'b' );
  TYPE1CHAR( "c", 'c' );
  TYPE1CHAR( "d", 'd' );
  TYPE1CHAR( "e", 'e' );
  TYPE1CHAR( "f", 'f' );
  TYPE1CHAR( "g", 'g' );
  TYPE1CHAR( "h", 'h' );
  TYPE1CHAR( "i", 'i' );
  TYPE1CHAR( "j", 'j' );
  TYPE1CHAR( "k", 'k' );
  TYPE1CHAR( "l", 'l' );
  TYPE1CHAR( "m", 'm' );
  TYPE1CHAR( "n", 'n' );
  TYPE1CHAR( "o", 'o' );
  TYPE1CHAR( "p", 'p' );
  TYPE1CHAR( "q", 'q' );
  TYPE1CHAR( "r", 'r' );
  TYPE1CHAR( "s", 's' );
  TYPE1CHAR( "t", 't' );
  TYPE1CHAR( "u", 'u' );
  TYPE1CHAR( "v", 'v' );
  TYPE1CHAR( "w", 'w' );
  TYPE1CHAR( "x", 'x' );
  TYPE1CHAR( "y", 'y' );
  TYPE1CHAR( "z", 'z' );
#if 0
  TYPE1CHAR( "dotlessi", CHAR_ );
  TYPE1CHAR( "dotlessj", CHAR_ );
  TYPE1CHAR( "weierstrass", CHAR_ );
  TYPE1CHAR( "vector", CHAR_ );
  TYPE1CHAR( "tie", CHAR_ );
#endif
  TYPE1CHAR( "space", ' ' );
// cmr8.pfb
#if 0
  TYPE1CHAR( "ff", CHAR_ );
  TYPE1CHAR( "fi", CHAR_ );
  TYPE1CHAR( "fl", CHAR_ );
  TYPE1CHAR( "ffi", CHAR_ );
  TYPE1CHAR( "ffl", CHAR_ );
  TYPE1CHAR( "grave", CHAR_ );
  TYPE1CHAR( "acute", CHAR_ );
  TYPE1CHAR( "caron", CHAR_ );
  TYPE1CHAR( "breve", CHAR_ );
  TYPE1CHAR( "macron", CHAR_ );
#endif
  TYPE1CHAR( "ring", CHAR_SDOT );
#if 0
  TYPE1CHAR( "cedilla", CHAR_ );
  TYPE1CHAR( "germandbls", CHAR_ );
  TYPE1CHAR( "ae", CHAR_ );
  TYPE1CHAR( "oe", CHAR_ );
  TYPE1CHAR( "oslash", CHAR_ );
  TYPE1CHAR( "AE", CHAR_ );
  TYPE1CHAR( "OE", CHAR_ );
  TYPE1CHAR( "Oslash", CHAR_ );
  TYPE1CHAR( "suppress", CHAR_ );
#endif
  TYPE1CHAR( "exclam", '!' );
  TYPE1CHAR( "quotedblright", '\"' );
  TYPE1CHAR( "numbersign", '#' );
  TYPE1CHAR( "dollar", '$' );
  TYPE1CHAR( "percent", '%' );
  TYPE1CHAR( "ampersand", '&' );
  TYPE1CHAR( "quoteright", '\'' );
  TYPE1CHAR( "parenleft", '(' );
  TYPE1CHAR( "parenright", ')' );
  TYPE1CHAR( "asterisk", '*' );
  TYPE1CHAR( "plus", '+' );
#if 0
  TYPE1CHAR( "hyphen", CHAR_ );
#endif
  TYPE1CHAR( "zero", '0' );
  TYPE1CHAR( "one", '1' );
  TYPE1CHAR( "two", '2' );
  TYPE1CHAR( "three", '3' );
  TYPE1CHAR( "four", '4' );
  TYPE1CHAR( "five", '5' );
  TYPE1CHAR( "six", '6' );
  TYPE1CHAR( "seven", '7' );
  TYPE1CHAR( "eight", '8' );
  TYPE1CHAR( "nine", '9' );
  TYPE1CHAR( "colon", ':' );
  TYPE1CHAR( "semicolon", ';' );
#if 0
  TYPE1CHAR( "exclamdown", CHAR_ );
#endif
  TYPE1CHAR( "equal", '=' );
#if 0
  TYPE1CHAR( "questiondown", CHAR_ );
#endif
  TYPE1CHAR( "question", '?' );
  TYPE1CHAR( "at", '@' );
  TYPE1CHAR( "bracketleft", '[' );
#if 0
  TYPE1CHAR( "quotedblleft", CHAR_ );
#endif
  TYPE1CHAR( "bracketright", ']' );
  TYPE1CHAR( "circumflex", '^' );
#if 0
  TYPE1CHAR( "dotaccent", CHAR_ );
  TYPE1CHAR( "quoteleft", CHAR_ );
  TYPE1CHAR( "endash", CHAR_ );
  TYPE1CHAR( "emdash", CHAR_ );
  TYPE1CHAR( "hungarumlaut", CHAR_ );
#endif
  TYPE1CHAR( "tilde", '~' );
#if 0
  TYPE1CHAR( "dieresis", CHAR_ );
#endif
// cmmi10.pfb
// cmsy10.pfb
  TYPE1CHAR( "minus", '-' );
#if 0
  TYPE1CHAR( "periodcentered", CHAR_ );
  TYPE1CHAR( "multiply", CHAR_ );
#endif
  TYPE1CHAR( "asteriskmath", CHAR_LOWAST );
#if 0
  TYPE1CHAR( "divide", CHAR_ );
  TYPE1CHAR( "diamondmath", CHAR_ );
  TYPE1CHAR( "plusminus", CHAR_ );
  TYPE1CHAR( "minusplus", CHAR_ );
#endif
  TYPE1CHAR( "circleplus", CHAR_OPLUS );
#if 0
  TYPE1CHAR( "circleminus", CHAR_ );
#endif
  TYPE1CHAR( "circlemultiply", CHAR_OTIMES );
#if 0
  TYPE1CHAR( "circledivide", CHAR_ );
  TYPE1CHAR( "circledot", CHAR_ );
  TYPE1CHAR( "circlecopyrt", CHAR_ );
  TYPE1CHAR( "openbullet", CHAR_ );
  TYPE1CHAR( "bullet", CHAR_ );
#endif
  TYPE1CHAR( "equivasymptotic", CHAR_ASYMP );
  TYPE1CHAR( "equivalence", CHAR_EQUIV );
#if 0
  TYPE1CHAR( "reflexsubset", CHAR_ );
  TYPE1CHAR( "reflexsuperset", CHAR_ );
#endif
  TYPE1CHAR( "lessequal", CHAR_LE );
  TYPE1CHAR( "greaterequal", CHAR_GE );
#if 0
  TYPE1CHAR( "precedesequal", CHAR_ );
  TYPE1CHAR( "followsequal", CHAR_ );
#endif
  TYPE1CHAR( "similar", CHAR_SIM );
#if 0
  TYPE1CHAR( "approxequal", CHAR_ );
#endif
  TYPE1CHAR( "propersubset", CHAR_SUB );
  TYPE1CHAR( "propersuperset", CHAR_SUP );
#if 0
  TYPE1CHAR( "lessmuch", CHAR_ );
  TYPE1CHAR( "greatermuch", CHAR_ );
  TYPE1CHAR( "precedes", CHAR_ );
  TYPE1CHAR( "follows", CHAR_ );
  TYPE1CHAR( "arrowleft", CHAR_ );
  TYPE1CHAR( "arrowright", CHAR_ );
  TYPE1CHAR( "arrowup", CHAR_ );
  TYPE1CHAR( "arrowdown", CHAR_ );
  TYPE1CHAR( "arrowboth", CHAR_ );
  TYPE1CHAR( "arrownortheast", CHAR_ );
  TYPE1CHAR( "arrowsoutheast", CHAR_ );
  TYPE1CHAR( "similarequal", CHAR_ );
  TYPE1CHAR( "arrowdblleft", CHAR_ );
  TYPE1CHAR( "arrowdblright", CHAR_ );
  TYPE1CHAR( "arrowdblup", CHAR_ );
  TYPE1CHAR( "arrowdbldown", CHAR_ );
  TYPE1CHAR( "arrowdblboth", CHAR_ );
  TYPE1CHAR( "arrownorthwest", CHAR_ );
  TYPE1CHAR( "arrowsouthwest", CHAR_ );
#endif
  TYPE1CHAR( "proportional", CHAR_PROP );
#if 0
  TYPE1CHAR( "prime", CHAR_ );
#endif
  TYPE1CHAR( "infinity", CHAR_INFIN );
  TYPE1CHAR( "element", CHAR_ISIN );
  TYPE1CHAR( "owner", CHAR_NI );
#if 0
  TYPE1CHAR( "triangle", CHAR_ );
  TYPE1CHAR( "triangleinv", CHAR_ );
  TYPE1CHAR( "negationslash", CHAR_ );
  TYPE1CHAR( "mapsto", CHAR_ );
#endif
  TYPE1CHAR( "universal", CHAR_ALL );
  TYPE1CHAR( "existential", CHAR_EXISTS );
  TYPE1CHAR( "logicalnot", CHAR_NEG );
  TYPE1CHAR( "emptyset", CHAR_EMPTY );
#if 0
  TYPE1CHAR( "Rfractur", CHAR_ );
  TYPE1CHAR( "Ifractur", CHAR_ );
  TYPE1CHAR( "latticetop", CHAR_ );
#endif
  TYPE1CHAR( "perpendicular", CHAR_PERP );
#if 0
  TYPE1CHAR( "aleph", CHAR_ );
#endif
  TYPE1CHAR( "union", CHAR_CUP );
  TYPE1CHAR( "intersection", CHAR_CAP );
#if 0
  TYPE1CHAR( "unionmulti", CHAR_ );
#endif
  TYPE1CHAR( "logicaland", CHAR_AND );
  TYPE1CHAR( "logicalor", CHAR_OR );
  TYPE1CHAR( "turnstileleft", CHAR_SEQUENT );
#if 0
  TYPE1CHAR( "turnstileright", CHAR_ );
  TYPE1CHAR( "floorleft", CHAR_ );
  TYPE1CHAR( "floorright", CHAR_ );
  TYPE1CHAR( "ceilingleft", CHAR_ );
  TYPE1CHAR( "ceilingright", CHAR_ );
#endif
  TYPE1CHAR( "braceleft", '{' );
  TYPE1CHAR( "braceright", '}' );
#if 0
  TYPE1CHAR( "angbracketleft", CHAR_ );
  TYPE1CHAR( "angbracketright", CHAR_ );
  TYPE1CHAR( "bar", CHAR_ );
  TYPE1CHAR( "bardbl", CHAR_ );
  TYPE1CHAR( "arrowbothv", CHAR_ );
  TYPE1CHAR( "arrowdblbothv", CHAR_ );
#endif
  TYPE1CHAR( "backslash", CHAR_BACKSLASH );
#if 0
  TYPE1CHAR( "wreathproduct", CHAR_ );
#endif
  TYPE1CHAR( "radical", CHAR_RADIC );
#if 0
  TYPE1CHAR( "coproduct", CHAR_ );
#endif
  TYPE1CHAR( "nabla", CHAR_NABLA );
  TYPE1CHAR( "integral", CHAR_INT );
#if 0
  TYPE1CHAR( "unionsq", CHAR_ );
  TYPE1CHAR( "intersectionsq", CHAR_ );
#endif
  TYPE1CHAR( "subsetsqequal", CHAR_SUBE );
  TYPE1CHAR( "supersetsqequal", CHAR_SUPE );
#if 0
  TYPE1CHAR( "section", CHAR_ );
  TYPE1CHAR( "dagger", CHAR_ );
  TYPE1CHAR( "daggerdbl", CHAR_ );
  TYPE1CHAR( "paragraph", CHAR_ );
  TYPE1CHAR( "club", CHAR_ );
#endif
  TYPE1CHAR( "diamond", CHAR_LOZ );
#if 0
  TYPE1CHAR( "heart", CHAR_ );
  TYPE1CHAR( "spade", CHAR_ );
#endif
// cmtt10.pfb
#if 0
  TYPE1CHAR( "quotesingle", CHAR_ );
  TYPE1CHAR( "visiblespace", CHAR_ );
  TYPE1CHAR( "quotedbl", CHAR_ );
  TYPE1CHAR( "asciicircum", CHAR_ );
  TYPE1CHAR( "underscore", CHAR_ );
  TYPE1CHAR( "asciitilde", CHAR_ );
#endif
// cmbx10.pfb
// cmr10.pfb
// cmmi10.pfb

}

void Type1Chars::AddTranslation( const char *l, UCHAR u )
{
  m_ltou[l] = u;

  if( m_utol[u] == NULL )
    m_utol[u] = l;
}

UCHAR Type1Chars::GetUnicode( const char* str )
{
  Type1ToUnicode::const_iterator i = m_ltou.find( str );

  if( i == m_ltou.end() )
  {
#ifdef DEBUG
    cout << "UNKNOWN TYPE1 SYMBOL: \\" << str << endl;
#endif
    return '?';
  }

  return (*i).second;
}

const char *Type1Chars::GetType1( UCHAR code )
{
  return m_utol[code];
}

