////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: chars/type1chars.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _TYPE1CHARS_H_
#define _TYPE1CHARS_H_

#include "util/hash.h"
#include "chars.h"

class Type1ToUnicode :
  public stlhash::hash_map<const char*, UCHAR, stlhash::hash<const char*>, eqstr>
{
};

class UnicodeToType1 :
  public stlhash::hash_map<UCHAR, const char*>
{
};

class Type1Chars
{
public:
  Type1Chars();

  void AddTranslation( const char *l, UCHAR u );

  UCHAR GetUnicode( const char* str );
  const char *GetType1( UCHAR code );

protected:
  Type1ToUnicode         m_ltou;
  UnicodeToType1         m_utol;
};

extern Type1Chars Type1Convertor;

#endif
