////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: export/export.cpp
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#include <iostream>
#include <string.h>
#include <malloc.h>

#include "util/myassert.h"
#include "util/fileexceptions.h"

#include "export.h"

ExportFile::ExportFile()
{
  m_sourcename  = NULL;
  m_isopen      = false;
  m_use_stdout  = false;
}

void ExportFile::Open( std::ofstream &file )
{
  ASSERT( m_isopen == false );

  ASSERT( false ); // TODO?
  //m_file = file;
}

void ExportFile::Open( const char *sourcename )
{
  ASSERT( m_isopen == false );

  if( sourcename == NULL )
  {
    m_use_stdout = true;
    m_sourcename = strdup( "stdout" );
    return;
  }

  m_sourcename = strdup( sourcename );

  m_file.open( m_sourcename );

  if( m_file == NULL )
    throw new FileOpenFailException( m_sourcename, errno );

  m_isopen = true;
}

void ExportFile::Close()
{
  if( m_isopen )
    m_file.close();

  if( m_sourcename != NULL )
    free( m_sourcename );

  m_sourcename = NULL;

  m_isopen = false;
  m_use_stdout  = false;
}

std::ostream& ExportFile::GetStream()
{
  ASSERT( m_isopen );

  if( m_use_stdout )
    return std::cout;
  else
    return m_file;
}

