////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: export/export.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _EXPORT_H_
#define _EXPORT_H_

#include <ostream>
#include <fstream>

namespace ProofLib
{
  class ProofDatabase;
}

class ExportModul
{
public:
  virtual ~ExportModul() {};

  virtual void Write( const ProofLib::ProofDatabase* proofdb ) = 0;
  virtual void Open( const char *sourcename ) = 0;  
  virtual void Close() = 0;  
};

class ExportFile : public ExportModul
{
public:
  ExportFile();

  virtual void Open( std::ofstream &file );  
  virtual void Open( const char *sourcename );  
  virtual void Close();  

protected:
  virtual std::ostream& GetStream();

private:
  char          *m_sourcename;
  std::ofstream  m_file;
  bool           m_isopen;
  bool           m_use_stdout;
};

#endif
