////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: term_operations.cpp
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#include <iostream> // TESTING
#include "util/myassert.h"
#include "util/sloc.h"
#include "libproof.h"
#include "expression_operations.h"

//#include "../printhlk.h"
//#include "../symbolhlk.h"


namespace ProofLib
{

////////////////////////////////////////////////////////////////////////////////
#if 0
DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( Variable, OperationCheckEquality, v )
{
  const SymbolNode *s = dynamic_cast<const SymbolNode*>(o);

  if( s == NULL )
    return false;

  for ( size_t i = 0; i < m_alpha_map.size(); i++ )
  {
    VarMap m = m_alpha_map[i];
    if ( m.first == v )
    {
      v = m.first;
      break;
    }
  }

  return ( v->GetSymbol() == s->GetSymbol() );
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( Constant, OperationCheckEquality, c )
{
  const SymbolNode *s = dynamic_cast<const SymbolNode*>( o );
  if ( s == NULL )
    return false;

  return ( c->GetSymbol() == s->GetSymbol() );
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( LambdaTerm, OperationCheckEquality, t )
{
  std::cerr << "checking LambdaTerm in OperationCheckEquality" << std::endl;

  bool ok = false;
  if ( const LambdaTerm *n_t = dynamic_cast<const LambdaTerm *> (o) )
  {
    if ( t->getVariables().GetChildCount() != n_t->getVariables().GetChildCount() )
    {
      return false;
    }

    // check for alpha-equivalence
    // FIXME: check whether variables of term2 are free in term1
    // and abort if this is the case!

    for ( unsigned int i = 0; i < t->getVariables().GetChildCount(); i++ )
    {
      m_alpha_map.push_back( VarMap( dynamic_cast<Variable*>( t->getVariables().GetTerm( i ) ), dynamic_cast<Variable*>( n_t->getVariables().GetTerm( i ) ) ) );
    }

    if ( t->ApplyCompare( *this, o ) )
    {
      ok = true;
    }

    for ( size_t i = 0; i < t->getVariables().GetChildCount(); i++ )
    {
      m_alpha_map.pop_back();
    }
    //if ( form != m_form )
    //  form->Detach();
  }

  if ( ok )
    std::cerr << "equal!" << std::endl;
  else
    std::cerr << "not equal!" << std::endl;

  return ok;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( SecondOrderVariable, OperationCheckEquality, v )
{
  const SymbolNode *s = dynamic_cast<const SymbolNode*>( o );
  if ( s == NULL )
    return false;

  return ( v->GetSymbol() == s->GetSymbol() ); 
}
#endif
////////////////////////////////////////////////////////////////////////////////


Variable* 
OperationGetEtaNf::getNormalVariable( size_t index, USTRING type_name )
{
  ASSERT( false );
  return NULL;
#if 0
  if ( index >= normal_variables.size() )
  {
  	for ( size_t i = normal_variables.size(); i <= index; i++)
    {
  	  normal_variables.push_back( NULL );
    }
  }
  
  if ( normal_variables[ index ] == NULL )
  {  
    // FIXME: get sourcelocation from somewhere else?
    SourceLocation sloc( "___INTERNAL_OperationGetAllVariableSubstitutions___",
                          0, 0);
     
    
    const HLK::VariableSymbol* vs = m_symtbl->NewVariable(
        USTRING(),
        type_name,
        true,
        sloc );
    Variable* new_v = Variable::New( m_ndb, vs );
    normal_variables[ index ] = new_v;
  }
  
  return normal_variables[ index ];
#endif
}

#if 0
DECLARE_APPLY_FUNCTION_HEAD( AtomFormula, Formula, OperationGetEtaNf, f )
{
  AbstractTermList newterms;

  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
    AbstractTerm *t = f->GetTerm( i );
    SecondOrderVariable *v = dynamic_cast<SecondOrderVariable*>( t ) ;
    if ( v != NULL )
    {
      const HLK::PredicateSymbol *s = dynamic_cast<const HLK::PredicateSymbol*>( v->GetSymbol() );
      ASSERT( s != NULL );
      TermList vars;
      for ( size_t j = 0; j < s->GetArity(); j++ )
      {
	const HLK::TypeSymbol *ts = s->GetArgType( j );
	vars.AddRight( getNormalVariable( j, ts->GetName() ) );
      }
      AtomFormula *af = AtomFormula::New( m_ndb, s, &vars, v );
      LambdaTerm *t = LambdaTerm::New( m_ndb, vars, af );

      newterms.AddRight( t );
    }

    // TODO: implement for DefinedSets
    //       recurse into subterms!
  }

  return AtomFormula::New( m_ndb, f->GetSymbol(), &newterms, f->GetSecondOrderVariable() );
}


DECLARE_APPLY_FUNCTION_HEAD( DefinedSet, SetTerm, OperationGetEtaNf, s )
{
  // TODO: convert arguments to eta-nf
  return ExpressionOperation::ApplyToDefinedSet( s );
}
#endif

DECLARE_APPLY_FUNCTION_HEAD( SecondOrderVariable, SetTerm, OperationGetEtaNf, v )
{
  ASSERT( false );
  return NULL;
#if 0
  const HLK::PredicateSymbol *s = dynamic_cast<const HLK::PredicateSymbol*>( v->GetSymbol() );
  ASSERT( s != NULL );
  TermList vars;
  for ( size_t j = 0; j < s->GetArity(); j++ )
  {
    const HLK::TypeSymbol *ts = s->GetArgType( j );
    vars.AddRight( getNormalVariable( j, ts->GetName() ) );
  }
  AtomFormula *af = AtomFormula::New( m_ndb, s, &vars, v );
  LambdaTerm *lt = LambdaTerm::New( m_ndb, vars, af );

//  std::cerr << "eta lt: ";
//  HLK::Print::PrintAbstractTerm( lt, std::cerr );
//  std::cerr << std::endl;

  return lt;
#endif
}

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD( Variable, Term, OperationReplaceTerm, v )
{
  if ( np == position )
  {
    return &replacement;
  }

  v->Attach();
  return v;
}

DECLARE_APPLY_FUNCTION_HEAD( Constant, Term, OperationReplaceTerm, c )
{
  if ( np == position )
  {
    return &replacement;
  }

  c->Attach();
  return c;
}

DECLARE_APPLY_FUNCTION_HEAD( Function, Term, OperationReplaceTerm, f )
{
  if ( np == position )
  {
    return &replacement;
  }
  

  AbstractTermList *tl = new AbstractTermList();
  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
    Push(i);
    AbstractTerm *t = DataNode::ApplyTo( f->GetTerm( i ), *this );
    Pop();

    tl->AddRight( t );
  }

  Function *new_f = Function::New( m_ndb, f->GetSymbol(), tl );
  return new_f;
}

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD( Variable, Term, OperationGetVariables, v )
{
  if( list.FindTerm( v ) < 0 )
    list.AddRight( v );

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD( QuantorFormula, Formula, OperationGetVariables, f )
{
  if( list.FindTerm( f->GetVariable() ) < 0 )
    list.AddRight( f->GetVariable() );

  Push(0);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  return f;
}

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD( Variable, Term, OperationGetAllVariables, v )
{
  if( list.FindTerm( v ) < 0 )
    list.AddRight( v );

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD( QuantorFormula, Formula, OperationGetAllVariables, f )
{
  if( list.FindTerm( f->GetVariable() ) < 0 )
    list.AddRight( f->GetVariable() );

  Push(0);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD( SecondOrderVariable, SetTerm, OperationGetAllVariables, v )
{
  if( list.FindTerm( v ) < 0 )
    list.AddRight( v );

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD( SecondOrderQuantorFormula, Formula, OperationGetAllVariables, f )
{
  if( list.FindTerm( f->GetSecondOrderVariable() ) < 0 )
    list.AddRight( f->GetSecondOrderVariable() );

  Push(0);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  return f;
}
////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD( Function, Term, OperationGetSubterms, f )
{
  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
    // FIXME: do not cast
    Term *t = dynamic_cast<Term*>( f->GetTerm( i ) );

    np.Push( i );
    list.AddRight( t );
    nps.Add( np );
    np.Pop();
  }

  return f;
}

////////////////////////////////////////////////////////////////////////////////
#if 0
DECLARE_APPLY_FUNCTION_HEAD( Variable, Term, OperationGetFirstAndSecondOrderVariables, v )
{
  if( list.FindDefinitionArgument( v ) < 0 )
    list.AddRight( v );

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD( AtomFormula, Formula, OperationGetFirstAndSecondOrderVariables, f )
{
  SecondOrderVariable *v = f->GetSecondOrderVariable();
  if( v != NULL && list.FindDefinitionArgument( v ) < 0 )
    list.AddRight( v );

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD( QuantorFormula, Formula, OperationGetFirstAndSecondOrderVariables, f )
{
  if( list.FindDefinitionArgument( f->GetVariable() ) < 0 )
    list.AddRight( f->GetVariable() );

  Push(0);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD( SecondOrderQuantorFormula, Formula, OperationGetFirstAndSecondOrderVariables, f )
{
  if( list.FindDefinitionArgument( f->GetSecondOrderVariable() ) < 0 )
    list.AddRight( f->GetSecondOrderVariable() );

  Push(0);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  return f;
}
#endif
////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD
  ( Variable, Term, OperationCountFreeVariables, v )
{
  if( bounded.FindTerm( v ) >= 0 )
    return v;

  varcount++;

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationCountFreeVariables, f )
{
  if( bounded.FindTerm( f->GetVariable() ) < 0 )
    bounded.AddRight( f->GetVariable() );

  Push(1);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  int pos = bounded.FindTerm( f->GetVariable() );

  if( pos >= 0 )
    bounded.RemoveAt( pos );

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( LambdaTerm, SetTerm, OperationCountFreeVariables, t )
{
  TermList vars = t->getVariables();

  for ( size_t i = 0; i < vars.GetChildCount(); i++ )
  {
    if( bounded.FindTerm( vars.GetTerm( i ) ) < 0 )
      bounded.AddRight( vars.GetTerm( i ) );
  }

  Push(1);
  DataNode::ApplyTo( t->getFormula(), *this );
  Pop();

  for ( size_t i = 0; i < vars.GetChildCount(); i++ )
  {

    int pos = bounded.FindTerm( vars.GetTerm( i ) );

    if( pos >= 0 )
      bounded.RemoveAt( pos );
  }

  return t;
}

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD
  ( Variable, Term, OperationCountBoundVariables, v )
{
  if( bounded.FindTerm( v ) < 0 )
    return v;

  varcount++;

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationCountBoundVariables, f )
{
  if( bounded.FindTerm( f->GetVariable() ) < 0 )
    bounded.AddRight( f->GetVariable() );

  Push(1);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  int pos = bounded.FindTerm( f->GetVariable() );

  if( pos >= 0 )
    bounded.RemoveAt( pos );

  return f;
}


DECLARE_APPLY_FUNCTION_HEAD
  ( LambdaTerm, SetTerm, OperationCountBoundVariables, t )
{
  std::cerr << "entering OperationCountBoundVariables->ApplyToLambdaTerm" << std::endl;
  TermList vars = t->getVariables();

  for ( size_t i = 0; i < vars.GetChildCount(); i++ )
  {
    if( bounded.FindTerm( vars.GetTerm( i ) ) < 0 )
    {
      std::cerr << "adding lambda-bound var" << std::endl;
      bounded.AddRight( vars.GetTerm( i ) );
    }
  }

  Push(1);
  DataNode::ApplyTo( t->getFormula(), *this );
  Pop();

  for ( size_t i = 0; i < vars.GetChildCount(); i++ )
  {

    int pos = bounded.FindTerm( vars.GetTerm( i ) );

    if( pos >= 0 )
      bounded.RemoveAt( pos );
  }

  return t;
}

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD
  ( Variable, Term, OperationGetFreeVariablesAndPositions, v )
{
  std::cerr << "entered OperationGetFreeVariablesAndPositions" << std::endl;
  if( bounded.FindTerm( v ) >= 0 )
    return v;

  if( list.FindTerm( v ) < 0 )
  {
    list.AddRight( v );
    size_t p = pos.size();
    pos.resize( p + 1 );
    pos[p].Add( np );
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationGetFreeVariablesAndPositions, f )
{
  std::cerr << "entered OperationGetFreeVariablesAndPositions" << std::endl;
  if( bounded.FindTerm( f->GetVariable() ) < 0 )
    bounded.AddRight( f->GetVariable() );

  Push(1);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  int pos = bounded.FindTerm( f->GetVariable() );

  if( pos >= 0 )
    bounded.RemoveAt( pos );

  return f;
}

const NodePointers&
OperationGetFreeVariablesAndPositions::GetPositions( size_t index ) const
{
  std::cerr << "entered OperationGetFreeVariablesAndPositions" << std::endl;
  ASSERT( index < list.GetChildCount() );
  return pos[index];
}

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD
  ( Variable, Term, OperationGetAllFreeVariablesAndPositions, v )
{
  std::cerr << "entered OperationGetAllFreeVariablesAndPositions" << std::endl;
  if( bounded.FindTerm( v ) >= 0 )
    return v;

  if( list.FindTerm( v ) < 0 )
  {
    list.AddRight( v );
    size_t p = pos.size();
    pos.resize( p + 1 );
    pos[p].Add( np );
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationGetAllFreeVariablesAndPositions, f )
{
  std::cerr << "entered OperationGetAllFreeVariablesAndPositions" << std::endl;
  if( bounded.FindTerm( f->GetVariable() ) < 0 )
    bounded.AddRight( f->GetVariable() );

  Push(1);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  int pos = bounded.FindTerm( f->GetVariable() );

  if( pos >= 0 )
    bounded.RemoveAt( pos );

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SecondOrderVariable, SetTerm, OperationGetAllFreeVariablesAndPositions, v )
{
  std::cerr << "entered OperationGetAllFreeVariablesAndPositions" << std::endl;
  if( bounded.FindTerm( v ) >= 0 )
    return v;

  if( list.FindTerm( v ) < 0 )
  {
    list.AddRight( v );
    size_t p = pos.size();
    pos.resize( p + 1 );
    pos[p].Add( np );
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SecondOrderQuantorFormula, Formula, OperationGetAllFreeVariablesAndPositions, f )
{
  std::cerr << "entered OperationGetAllFreeVariablesAndPositions" << std::endl;
  if( bounded.FindTerm( f->GetSecondOrderVariable() ) < 0 )
    bounded.AddRight( f->GetSecondOrderVariable() );

  Push(1);
  DataNode::ApplyTo( f->GetFormula(), *this );
  Pop();

  int pos = bounded.FindTerm( f->GetSecondOrderVariable() );

  if( pos >= 0 )
    bounded.RemoveAt( pos );

  return f;
}

const NodePointers&
OperationGetAllFreeVariablesAndPositions::GetPositions( size_t index ) const
{
  std::cerr << "entered OperationGetAllFreeVariablesAndPositions" << std::endl;
  ASSERT( index < list.GetChildCount() );
  return pos[index];
}


////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationGetFreeVariables, f )
{
  bool bMyVarIsAlsoFree = ( list.FindTerm( f->GetVariable() ) >= 0 );

  ExpressionOperation::ApplyToQuantorFormula( f );

  if( bMyVarIsAlsoFree )
    return f;

  int pos = list.FindTerm( f->GetVariable() );

  if( pos >= 0 )
    list.RemoveAt( pos );

  return f;
}

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationGetAllFreeVariables, f )
{
  bool bMyVarIsAlsoFree = ( list.FindTerm( f->GetVariable() ) >= 0 );

  ExpressionOperation::ApplyToQuantorFormula( f );

  if( bMyVarIsAlsoFree )
    return f;

  int pos = list.FindTerm( f->GetVariable() );

  if( pos >= 0 )
    list.RemoveAt( pos );

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SecondOrderQuantorFormula, Formula, OperationGetAllFreeVariables, f )
{
  bool bMyVarIsAlsoFree = ( list.FindTerm( f->GetSecondOrderVariable() ) >= 0 );

  ExpressionOperation::ApplyToSecondOrderQuantorFormula( f );

  if( bMyVarIsAlsoFree )
    return f;

  int pos = list.FindTerm( f->GetSecondOrderVariable() );

  if( pos >= 0 )
    list.RemoveAt( pos );

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( LambdaTerm, SetTerm, OperationGetAllFreeVariables, t )
{
  //FIXME: only considers first variable bound!
  bool bMyVarIsAlsoFree = ( list.FindTerm( t->getVariables().GetTerm(0) ) >= 0 );

  ExpressionOperation::ApplyToLambdaTerm( t );

  if( bMyVarIsAlsoFree )
    return t;

  int pos = list.FindTerm( t->getVariables().GetTerm(0) );

  if( pos >= 0 )
    list.RemoveAt( pos );

  return t;
}



////////////////////////////////////////////////////////////////////////////////
#if 0
DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationGetFreeFirstAndSecondOrderVariables, f )
{
  bool bMyVarIsAlsoFree = ( list.FindDefinitionArgument( f->GetVariable() ) >= 0 );

  FormulaOperation::ApplyToQuantorFormula( f );

  if( bMyVarIsAlsoFree )
    return f;

  int pos = list.FindDefinitionArgument( f->GetVariable() );

  if( pos >= 0 )
    list.RemoveAt( pos );

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SecondOrderQuantorFormula, Formula, OperationGetFreeFirstAndSecondOrderVariables, f )
{
  bool bMyVarIsAlsoFree = ( list.FindDefinitionArgument( f->GetSecondOrderVariable() ) >= 0 );

  FormulaOperation::ApplyToSecondOrderQuantorFormula( f );

  if( bMyVarIsAlsoFree )
    return f;

  int pos = list.FindDefinitionArgument( f->GetSecondOrderVariable() );

  if( pos >= 0 )
    list.RemoveAt( pos );

  return f;
}
#endif

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationGetBoundedVariables, f )
{
  if( list.FindTerm( f->GetVariable() ) < 0 )
    list.AddRight( f->GetVariable() );

  return f;
}

////////////////////////////////////////////////////////////////////////////////

std::ostream& OperationGetAllVariableSubstitutions::ToString( std::ostream &out ) const
{
  for( size_t i = 0; i < vars.GetChildCount(); i++ )
  {
    if( i != 0 ) out << std::endl;
//    HLK::Print::PrintAbstractTerm( vars.GetTerm( i ), out );
//    out << " <- ";
//    std::set<AbstractTerm*>::iterator it;
//    out << "{ ";
//    for ( it = reps[i].begin(); it != reps[i].end(); it++ )
//    {
//      HLK::Print::PrintAbstractTerm( (*it), out );
//      out << ", ";
//    }
//    out << "}";
  }

  return out;
}

const std::set<AbstractTerm*> OperationGetAllVariableSubstitutions::GetSubstSet( size_t index ) const
{
  ASSERT( index < GetCount() );
  return reps[index];
}

void OperationGetAllVariableSubstitutions::SetSubstSet( size_t index, std::set<AbstractTerm*> &s )
{
  reps[index] = s;
}

const AbstractTerm* OperationGetAllVariableSubstitutions::GetSubst( size_t index ) const
{
  std::set<AbstractTerm*> substs = GetSubstSet( index );
  
  // if substitution is first order, there is only one substitution in the set

  std::set<AbstractTerm*>::iterator i = substs.begin();
  Term* t = dynamic_cast<Term*>( (*i) );
  if ( t != NULL ) 
    return t;

  // else we choose a "most general" lambdasubstitution from the set

  LambdaTerm *res = NULL;
  int varcount = -1;
  
  for ( i = substs.begin();
        i != substs.end(); i++)
  {
  	// most general == most bound variable occurences (=> most occurrences of variables bound by head lambda)
  	TermList tl;
	LambdaTerm* lt = dynamic_cast<LambdaTerm*>( (*i) );
	ASSERT( lt != NULL );
  	OperationCountBoundVariables op( tl );
  	lt->Apply( op );
  	int num = op.GetCount();

	std::cerr << "found " << num << " bound variables" << std::endl;

  	if ( num > varcount )
  	{
  	  varcount = num;
  	  res = lt;
  	}
  }
  
  ASSERT( res != NULL );
  
  return res;
}

Variable* 
OperationGetAllVariableSubstitutions::getNormalVariable( size_t index, USTRING type_name )
{
  ASSERT( false );
  return NULL;
#if 0
  if ( index >= normal_variables.size() )
  {
  	for ( size_t i = normal_variables.size(); i <= index; i++)
    {
  	  normal_variables.push_back( NULL );
    }
  }
  
  if ( normal_variables[ index ] == NULL )
  {  
    // FIXME: get sourcelocation from somewhere else?
    SourceLocation sloc( "___INTERNAL_OperationGetAllVariableSubstitutions___",
                          0, 0);
     
    
    const HLK::VariableSymbol* vs = m_symtbl->NewVariable(
        USTRING(),
        type_name,
        true,
        sloc );
    Variable* new_v = Variable::New( m_ndb, vs );
    normal_variables[ index ] = new_v;
  }
  
  return normal_variables[ index ];
#endif
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( AtomFormula, OperationGetAllVariableSubstitutions, f )
{
  ASSERT( false );
  return NULL;
#if 0
  std::cerr << "in OperationGetAllVariableSubstitutions->applyToAtomFormula" << std::endl;
  if ( f == o )
  {
  	// atoms are equal
    std::cerr << "atoms are equal" << std::endl;
    return true;
  }

  SecondOrderVariable *var2 = f->GetSecondOrderVariable();

  if ( var2 == NULL )
  {
    // atom formula constant, try first order substitution
    return ExpressionCompareOperation::ApplyToAtomFormula( f, o );
  }

  const Formula *f2 = dynamic_cast<const Formula*>(o);
  
  ASSERT( f2 != NULL );

  // collect terms appearing in formula, together with
  // a set of variables with size equal to the arity of
  // the variable atom formula

  TermList formula_terms;
  NodePointers formula_term_positions;
  OperationGetTerms op_gt( formula_terms, formula_term_positions );
  DataNode::ApplyTo( const_cast<DataNode*>(o), op_gt ) ;

//  std::cerr << "applied OperationGetTerms to ";
//  HLK::Print::PrintFormula( f2, std::cerr );
//  std::cerr << std::endl;
//  std::cerr << "formula_terms.GetChildCount() = " << formula_terms.GetChildCount() << std::endl;
//  std::cerr << "formula_term_positions.GetCount() = " << formula_term_positions.GetCount() << std::endl;

  TermList variables;
  for (unsigned int i = 0; i < f->GetChildCount(); i++)
  {
    // create new variables for lambda term
    // FIXME: do not cast
    Term *t = dynamic_cast<Term *>( f->GetTerm(i) );
    USTRING type_name;
    Variable *v;
    Function *f;
    Constant *c;
     
    if ( (v = dynamic_cast<Variable*>(t)) != NULL )
    {
     const HLK::VariableSymbol* vs = dynamic_cast<const HLK::VariableSymbol*>(v->GetSymbol());
     ASSERT( vs != NULL );
     type_name = vs->GetType()->GetName();
    }
    else if ( (f = dynamic_cast<Function*>(t)) != NULL)
    {
      const HLK::FunctionSymbol* fs = dynamic_cast<const HLK::FunctionSymbol*>(f->GetSymbol());
      ASSERT( fs != NULL );
      type_name = fs->GetType()->GetName();
    }
    else if ( (c = dynamic_cast<Constant*>(t)) != NULL)
    {
      const HLK::ConstantSymbol* cs = dynamic_cast<const HLK::ConstantSymbol*>(c->GetSymbol());
      ASSERT( cs != NULL );
      type_name = cs->GetType()->GetName();
    }
    else
      ASSERT( false );
    
    
    Variable* new_v = getNormalVariable( i, type_name ); 
    variables.AddRight( new_v );
  }

  TermList arguments;
  
  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
    // FIXME: do not cast
  	arguments.AddRight( dynamic_cast<Term *>( f->GetTerm( i ) ) );
  }

  // create all permutations of terms and variables of
  // length equal to the arity of the variable atom formula
  
  permutations.clear();
  createPermutedFormulas( formula_term_positions,
                          //NodePointer(),
                          formula_terms,
                          variables,
                          arguments,
                          0,
                          const_cast<Formula*>(f2) );
 
  std::set<AbstractTerm*> lambda_terms;
  std::cerr << "creating lambdaterms" << std::endl; 
  for ( size_t i = 0; i < permutations.size(); i++ )
  {
//#if 0
        std::cerr << "creating lambdaterm from permutation: ";
	HLK::Print::PrintFormula( permutations[i], std::cerr );
	std::cerr << std::endl;
//#endif
  	LambdaTerm *lt = LambdaTerm::New( m_ndb, variables, permutations[i] );
  	lambda_terms.insert( lt );
  }


  // variable already found?
  int p = -1;
  for (unsigned int i = 0; i < vars.GetChildCount(); i++)
  {
    if ( vars.GetTerm( i ) == var2 )
      p = i;
  }

  if( p >= 0 )
  {
    // intersect sets of lambda terms
    std::cerr << "intersecting, old substitution:" << std::endl;
    ToString( std::cerr );
    std::cerr << std::endl;
    std::set<AbstractTerm*> new_lambda_terms;
    std::set_intersection(reps[p].begin(), reps[p].end(),
       lambda_terms.begin(), lambda_terms.end(),
       std::insert_iterator< std::set<AbstractTerm*> >(new_lambda_terms,
                                                     new_lambda_terms.begin() ) );
    reps[p] = new_lambda_terms;
    
    if ( reps[p].empty() )
    {
      return false;
    }

    return true;
  }
  
  // is this a bounded variable?
  if( bounded.FindTerm( var2 ) != -1 ) 
    return true;

  p = pos.size();
  pos.resize( p + 1 );
  pos[p].var = np;
  pos[p].substs.Add( np );
  vars.AddRight( var2 );
  reps.resize( p + 1 );
  reps[p] = lambda_terms;
  std::cerr << "setting initial subst:" << std::endl;
  ToString( std::cerr );
  std::cerr << std::endl;

  if ( reps[p].empty() )
    return false;

  return true;
#endif
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( SecondOrderQuantorFormula, OperationGetAllVariableSubstitutions, f )
{
  SecondOrderVariable *v = f->GetSecondOrderVariable();

  bool already = ( bounded.FindTerm( v ) != -1 );

  if( !already )
    bounded.AddRight( v );

  bool ok = ExpressionCompareOperation::ApplyToSecondOrderQuantorFormula( f, o );

  if( !already )
  {
    int pos = 
      bounded.FindTerm( v );
    if ( pos != -1 )
      bounded.RemoveAt( pos );
  }

  return ok;
}

void OperationGetAllVariableSubstitutions::createPermutedFormulas( NodePointers &term_positions,
                                                              TermList &terms,
							      TermList &variables,
							      TermList &arguments,
							      size_t pos,
							      Formula *f )
{
//  std::cerr << "creating permutations:" << std::endl;
//  std::cerr << "f: ";
//  HLK::Print::PrintFormula( f, std::cerr );
//  std::cerr << std::endl;
//  std::cerr << "terms: ";
//  for ( size_t i = 0; i < terms.GetChildCount(); i++)
//  {
//    if ( i>0 ) std::cerr << ", ";
//    HLK::Print::PrintTerm( terms.GetTerm( i ), std::cerr ) ;
//  }
//  std::cerr << std::endl;

  std::vector<Formula*>::iterator i;
  i = find( permutations.begin(), permutations.end(), f );
  if ( terms.GetChildCount() == 0  && i == permutations.end() )
  {
#if 0
    std::cerr << "Adding permutation: ";
    HLK::Print::PrintFormula( f, std::cerr );
    std::cerr << std::endl;
#endif
    permutations.push_back( f );
    return;
  }

  for ( size_t i = 0; i < terms.GetChildCount(); i++ )
  {
    Term *t = terms.GetTerm( i );
    NodePointer t_pos = term_positions[ i ];
#if 0
    std::cerr << "considering term ";
    HLK::Print::PrintTerm( t, std::cerr );
    std::cerr << " at pos ";
    t_pos.Dump( std::cerr ) ;
    std::cerr << std::endl;
#endif
    for ( size_t j = 0; j < arguments.GetChildCount(); j++ )
    {
      Term *arg = arguments.GetTerm( j );
#if 0
      std::cerr << "considering argument: ";
      HLK::Print::PrintTerm( arg, std::cerr );
      std::cerr << std::endl;
#endif
      if ( t == arg )
      {
#if 0
	std::cerr << "they are equal" << std::endl;
        std::cerr << "substituting ";
	HLK::Print::PrintTerm( variables.GetTerm( j ), std::cerr );
	std::cerr << " for term at pos ";
       	t_pos.Dump( std::cerr );
	std::cerr << std::endl;
#endif
        OperationReplaceTerm op_rt( m_ndb, *(variables.GetTerm( j )), t_pos );
  	Formula *new_f = DataNode::ApplyTo( f, op_rt );
#if 0
        std::cerr << "new_f: ";
	HLK::Print::PrintFormula( new_f, std::cerr );
	std::cerr << std::endl;
#endif
	TermList newterms;
	NodePointers newpointers;
#if 0
        std::cerr << "new termlist: ";
#endif
	for ( size_t k = 0; k < terms.GetChildCount(); k++ )
	{
          if ( k != i )
	  {
#if 0
	    HLK::Print::PrintTerm( terms.GetTerm( k ), std::cerr );
	    std::cerr << ", ";
#endif
	    newterms.AddRight( terms.GetTerm( k ) ) ;
	    newpointers.Add( term_positions[ k ] ) ;
	  }
	}
#if 0
	std::cerr << std::endl;
#endif
	createPermutedFormulas( newpointers, newterms, variables, arguments, pos, new_f );
      }


      if ( blacklist.FindTerm( t ) == -1 && bounded.FindTerm(t) == -1 )
      {
        TermList subterms;
        NodePointers subpointers;
        OperationGetSubterms op_sub( subterms, subpointers, t_pos );
        DataNode::ApplyTo( t, op_sub );
        createPermutedFormulas( subpointers, subterms, variables, arguments, pos, f );
      }
    }
  }
}

#if 0
void OperationGetLambdaSubstitutions::createPermutedFormulas( NodePointers &term_positions,
                                                              //NodePointer &current,
                                                              TermList &terms,
                                                              TermList &variables,
                                                              TermList &arguments,
                                                              size_t pos,
                                                              Formula *f )
{
  if ( term_positions.GetCount() - pos == 1)
  {
  	if ( blacklist.FindTerm( terms.GetTerm( pos ) ) == -1 )
  	{
  	  permutations.push_back( f );
  	}
  	for ( size_t i = 0; i < variables.GetChildCount(); i++ )
  	{
  	  if ( arguments.GetTerm( i ) == terms.GetTerm( pos ) )
  	  {
  	  	OperationReplaceTerm op_rt( m_ndb, *(variables.GetTerm( i )), term_positions[ pos ] );
  	  	Formula *new_f = DataNode::ApplyTo( f, op_rt );
  	  	permutations.push_back( new_f );
  	  }
  	}

  	return;
  }

  for ( size_t i = 0; i < variables.GetChildCount(); i++ )
  {
    if ( arguments.GetTerm( i ) == terms.GetTerm( pos ) )
  	{
  	  OperationReplaceTerm op_rt( m_ndb, *(variables.GetTerm( i )), term_positions[ pos ] );
  	  Formula *new_f = DataNode::ApplyTo( f, op_rt );

	  std::cerr << "new_f: " << std::endl;
	  HLK::Print::PrintFormula( new_f, std::cerr );

          createPermutedFormulas( term_positions, /*term_positions[ pos ],*/ terms, variables, arguments, pos+1, new_f );
  	}
  	if ( blacklist.FindTerm( terms.GetTerm( pos ) ) == -1 )
  	{
  	  createPermutedFormulas( term_positions, /*current,*/ terms, variables, arguments, pos+1, f );
  	}
  }
}
#endif

void OperationGetAllVariableSubstitutions::Clear()
{
  while( vars.GetChildCount() > 0 ) vars.RemoveAt(0);
  reps.clear();
  while( bounded.GetChildCount() > 0 ) bounded.RemoveAt(0);
  while( equals.GetChildCount() > 0 ) equals.RemoveAt(0);
  pos.clear();
  np.Clear();
}

bool OperationGetAllVariableSubstitutions::CheckForSubstitutions(
  DataNode *general, DataNode *instance )
{
  Clear();
  return general->ApplyCompare( *this, instance );
}

const AbstractTerm* OperationGetAllVariableSubstitutions::GetVar( size_t index ) const
{
  ASSERT( index < GetCount() );
  return vars.GetTerm(index);
}

const NodePointer& OperationGetAllVariableSubstitutions::GetVarPos( size_t index ) const
{
  ASSERT( index < GetCount() );
  return pos[index].var;
}

const NodePointers&
OperationGetAllVariableSubstitutions::GetSubstPos( size_t index ) const
{
  ASSERT( index < GetCount() );
  return pos[index].substs;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( Variable, OperationGetAllVariableSubstitutions, v )
{
  if( !equals_too && v == o )
  {
    // this var is already substituted, partial substition not allowed here!
    if( vars.FindTerm( v ) >= 0 )
      return false;

    equals.AddRight( (Term*) v );

    return true;
  }

  const Term *t = o->CastTo<const Term>();

  if( t == NULL )
    return false;

  // variable already found?
  int p = vars.FindTerm( v );
  if( p >= 0 )
  {
    const Term *st = dynamic_cast<const Term*>( GetSubst( p ) );
    ASSERT( st != NULL );

    // variable has to be substituted with the same term!
    if( st != t )
      return false;

    pos[p].substs.Add( np );
    return true;
  }

  // was there already a position, where this var wasn't substituted?
  if( equals.FindTerm( v ) >= 0 ) 
    return false;

  // is this a bounded variable?
  if( bounded.FindTerm( v ) >= 0 ) 
    return true;

  p = pos.size();
  pos.resize( p + 1 );
  pos[p].var = np;
  pos[p].substs.Add( np );
  vars.AddRight( const_cast<Variable*>( v ) );
  // insert singleton set for t
  AbstractTerm *at = const_cast<Term*>( t );
  std::set<AbstractTerm*> S;
  S.insert( at );
  reps.push_back( S );

  return true;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( QuantorFormula, OperationGetAllVariableSubstitutions, f )
{
  Variable *v = f->GetVariable();

  bool already = ( bounded.FindTerm( v ) >= 0 );

  if( !already )
    bounded.AddRight( v );

  bool ok = ExpressionCompareOperation::ApplyToQuantorFormula( f, o );

  if( !already )
  {
    int pos = bounded.FindTerm( v );
    bounded.RemoveAt( pos );
  }

  return ok;
}


////////////////////////////////////////////////////////////////////////////////

void OperationGetVariableSubstitutions::Clear()
{
  while( vars.GetChildCount() > 0 ) vars.RemoveAt(0);
  while( reps.GetChildCount() > 0 ) reps.RemoveAt(0);
  while( bounded.GetChildCount() > 0 ) bounded.RemoveAt(0);
  while( equals.GetChildCount() > 0 ) equals.RemoveAt(0);
  pos.clear();
  np.Clear();
}

bool OperationGetVariableSubstitutions::CheckForSubstitutions(
  DataNode *general, DataNode *instance )
{
  Clear();
  return general->ApplyCompare( *this, instance );
}

const Variable* OperationGetVariableSubstitutions::GetVar( size_t index ) const
{
  ASSERT( index < GetCount() );
  return vars.GetTerm(index)->CastTo<const Variable>();
}

const Term* OperationGetVariableSubstitutions::GetSubst( size_t index ) const
{
  ASSERT( index < GetCount() );
  return reps.GetTerm(index);
}

const NodePointer& OperationGetVariableSubstitutions::GetVarPos( size_t index ) const
{
  ASSERT( index < GetCount() );
  return pos[index].var;
}

const NodePointers&
OperationGetVariableSubstitutions::GetSubstPos( size_t index ) const
{
  ASSERT( index < GetCount() );
  return pos[index].substs;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( Variable, OperationGetVariableSubstitutions, v )
{
  if( !equals_too && v == o )
  {
    // this var is already substituted, partial substition not allowed here!
    if( vars.FindTerm( v ) >= 0 )
      return false;

    equals.AddRight( (Term*) v );

    return true;
  }

  const Term *t = o->CastTo<const Term>();

  if( t == NULL )
    return false;

  // variable already found?
  int p = vars.FindTerm( v );
  if( p >= 0 )
  {
    // variable has to be substituted with the same term!
    if( reps.GetTerm(p) != t )
      return false;

    pos[p].substs.Add( np );
    return true;
  }

  // was there already a position, where this var wasn't substituted?
  if( equals.FindTerm( v ) >= 0 ) 
    return false;

  // is this a bounded variable?
  if( bounded.FindTerm( v ) >= 0 ) 
    return true;

  p = pos.size();
  pos.resize( p + 1 );
  pos[p].var = np;
  pos[p].substs.Add( np );
  vars.AddRight( (Term*) v );
  reps.AddRight( (Term*) t );

  return true;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( QuantorFormula, OperationGetVariableSubstitutions, f )
{
  Variable *v = f->GetVariable();

  bool already = ( bounded.FindTerm( v ) >= 0 );

  if( !already )
    bounded.AddRight( v );

  bool ok = ExpressionCompareOperation::ApplyToQuantorFormula( f, o );

  if( !already )
  {
    int pos = bounded.FindTerm( v );
    bounded.RemoveAt( pos );
  }

  return ok;
}

////////////////////////////////////////////////////////////////////////////////

OperationAllVariableSubstitution::OperationAllVariableSubstitution(
  ProofDatabase *pdb, const AbstractTerm *v, const AbstractTerm *subst )
{
  ASSERT( pdb != NULL );
  m_ndb = pdb->GetNodeDatabase();
  m_pdb = pdb;

  AddSubstitution( v, subst );
}

OperationAllVariableSubstitution::OperationAllVariableSubstitution(
  NodeDatabase *ndb, const AbstractTerm *v, const AbstractTerm *subst )
{
  ASSERT( ndb != NULL );
  m_ndb = ndb;
  m_pdb = NULL;

  AddSubstitution( v, subst );
}

OperationAllVariableSubstitution::OperationAllVariableSubstitution(
  NodeDatabase *ndb, const AllVariableSubstitution &subst )
{
  ASSERT( ndb != NULL );
  m_ndb = ndb;
  m_pdb = NULL;

  for( size_t i = 0; i < subst.GetCount(); i++ )
    AddSubstitution( subst.GetVar(i), subst.GetSubst(i) );
}

OperationAllVariableSubstitution::OperationAllVariableSubstitution(
  NodeDatabase *ndb )
{
  ASSERT( ndb != NULL );
  m_ndb = ndb;
  m_pdb = NULL;
}

OperationAllVariableSubstitution::OperationAllVariableSubstitution(
  ProofDatabase *pdb )
{
  ASSERT( pdb != NULL );
  m_pdb = pdb;
  m_ndb = pdb->GetNodeDatabase() ;
}

void OperationAllVariableSubstitution::AddSubstitution(
  const AbstractTerm *v, const AbstractTerm *subst )
{
  ASSERT( v != NULL );
  ASSERT( subst != NULL );
  substitutions.push_back( Substitution( v, subst ) );
  m_positions.resize( substitutions.size() );
}

const AbstractTerm* OperationAllVariableSubstitution::GetVar( size_t index ) const
{
  ASSERT( index < GetCount() );
  return substitutions[index].first;
}

const AbstractTerm* OperationAllVariableSubstitution::GetSubst( size_t index ) const
{
  ASSERT( index < GetCount() );
  return substitutions[index].second;
}

const NodePointers&
OperationAllVariableSubstitution::GetPositions( size_t index ) const
{
  ASSERT( index < substitutions.size() );
  ASSERT( index < m_positions.size() );

  return m_positions[index];
}

DECLARE_APPLY_FUNCTION_HEAD( Variable, Term, OperationAllVariableSubstitution, v )
{
#if 0
  if( v != this->v )
    return v;

  return (Term*) t;
#endif
  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( v != substitutions[i].first )
      continue; // not "this" variable

    if( bounded.FindTerm( substitutions[i].first ) >= 0 )
      continue; // variable is bounded

    m_positions[i].Add( m_np );
    return (Term*) substitutions[i].second;
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationAllVariableSubstitution, f )
{
  // don't replace bounded vars!
  bounded.AddRight( f->GetVariable() );
#if 0
  if( v == f->GetVariable() )
   return f;
#endif

  ProofLib::Formula *f_1 = ExpressionOperation::ApplyToQuantorFormula( f );

  ASSERT( bounded.GetTerm( bounded.GetChildCount() - 1 ) == f->GetVariable() );
  bounded.RemoveAt( bounded.GetChildCount() - 1 );

  return f_1;
}

std::ostream& OperationAllVariableSubstitution::ToString( std::ostream &out ) const
{
  typedef std::pair< const AbstractTerm*, const AbstractTerm* > Substitution;

  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( i != 0 ) out << ", ";
    substitutions[i].first->ToString(out);
    out << " <- ";
    substitutions[i].second->ToString(out);
  }

  return out;
}

DECLARE_APPLY_FUNCTION_HEAD( AtomFormula, Formula, OperationAllVariableSubstitution, af )
{
  // first, apply substitution to subterms
  AtomFormula* new_f = dynamic_cast<AtomFormula*>( ExpressionOperation::ApplyToAtomFormula( af ) );
  ASSERT( new_f != NULL );

  // now apply substitution, if this is a predicate variable
  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( new_f->GetSecondOrderVariable() != substitutions[i].first )
      continue; // not "this" variable

    if( bounded.FindTerm( substitutions[i].first ) != -1 )
      continue; // variable is bounded

    m_positions[i].Add( m_np );
    
    TermList tl;
    for ( unsigned int j = 0; j < new_f->GetChildCount(); j++)
    {
      Term *t = dynamic_cast<Term*>( new_f->GetTerm( j ) );
      ASSERT( t != NULL );
      tl.AddRight( t );
    }

    const LambdaTerm* lt = dynamic_cast<const LambdaTerm*>( substitutions[i].second );
    if ( lt != NULL )
    { 
      Formula *f = lt->apply( m_pdb, tl );
//      std::cerr << "applied lambda term to yield: ";
//      HLK::Print::PrintFormula( f, std::cerr );
//      std::cerr << std::endl;
      return f;
    }

    const SecondOrderVariable* v2 = dynamic_cast<const SecondOrderVariable*>( substitutions[i].second );
    if ( v2 != NULL )
    {
//      std::cerr << "PERFORMING VARIABLE RENAMING ";
//      HLK::Print::PrintAbstractTerm(  new_f->GetSecondOrderVariable(), std::cerr );
//      std::cerr << " -> ";
//      HLK::Print::PrintAbstractTerm( v2, std::cerr );
//      std::cerr << std::endl;

      // FIXME: const cast!
      return AtomFormula::New( m_ndb, v2->GetSymbol(), &tl, const_cast<SecondOrderVariable*>( v2 ) );
    }

    const DefinedSet* s = dynamic_cast<const DefinedSet*>( substitutions[i].second );
    ASSERT( s != NULL );
    // FIXME const cast
    return DefinedSetFormula::New( m_ndb, const_cast<DefinedSet*>( s ), &tl );
    
  }

  return new_f;
}

DECLARE_APPLY_FUNCTION_HEAD( SecondOrderVariable, SetTerm, OperationAllVariableSubstitution, v )
{
  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( v != substitutions[i].first )
      continue; // not "this" variable

    if( bounded.FindTerm( substitutions[i].first ) != -1 )
      continue; // variable is bounded

    m_positions[i].Add( m_np );
    
    const LambdaTerm* lt = dynamic_cast<const LambdaTerm*>( substitutions[i].second );
    if ( lt != NULL )
    {
      // FIXME const cast
      return const_cast<LambdaTerm*>( lt );
    }

    const SecondOrderVariable* v2 = dynamic_cast<const SecondOrderVariable*>( substitutions[i].second );
    if ( v2 != NULL )
    {
      // FIXME const cast
      return const_cast<SecondOrderVariable*>( v2 );
    }

    const DefinedSet* s = dynamic_cast<const DefinedSet*>( substitutions[i].second );
    ASSERT( s != NULL );
    // FIXME const cast
    return const_cast<DefinedSet*>( s );
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SecondOrderQuantorFormula, Formula, OperationAllVariableSubstitution, f )
{
  // don't replace bounded vars!
  bounded.AddRight( f->GetSecondOrderVariable() );
#if 0
  if( v == f->GetVariable() )
   return f;
#endif

  ProofLib::Formula *f_1 = ExpressionOperation::ApplyToSecondOrderQuantorFormula( f );

  ASSERT( bounded.GetTerm( bounded.GetChildCount() - 1 ) == f->GetSecondOrderVariable() );
  bounded.RemoveAt( bounded.GetChildCount() - 1 );

  return f_1;
}



////////////////////////////////////////////////////////////////////////////////

OperationVariableSubstitution::OperationVariableSubstitution(
  ProofDatabase *pdb, const Variable *v, const Term *subst )
{
  ASSERT( pdb != NULL );
  m_ndb = pdb->GetNodeDatabase();
  m_pdb = pdb;

  AddSubstitution( v, subst );
}

OperationVariableSubstitution::OperationVariableSubstitution(
  NodeDatabase *ndb, const Variable *v, const Term *subst )
{
  ASSERT( ndb != NULL );
  m_ndb = ndb;
  m_pdb = NULL;

  AddSubstitution( v, subst );
}

OperationVariableSubstitution::OperationVariableSubstitution(
  NodeDatabase *ndb, const VariableSubstitution &subst )
{
  ASSERT( ndb != NULL );
  m_ndb = ndb;
  m_pdb = NULL;

  for( size_t i = 0; i < subst.GetCount(); i++ )
    AddSubstitution( subst.GetVar(i), subst.GetSubst(i) );
}

OperationVariableSubstitution::OperationVariableSubstitution(
  NodeDatabase *ndb )
{
  ASSERT( ndb != NULL );
  m_ndb = ndb;
  m_pdb = NULL;
}

OperationVariableSubstitution::OperationVariableSubstitution(
  ProofDatabase *pdb )
{
  ASSERT( pdb != NULL );
  m_pdb = pdb;
  m_ndb = pdb->GetNodeDatabase() ;
}

void OperationVariableSubstitution::AddSubstitution(
  const Variable *v, const Term *subst )
{
  ASSERT( v != NULL );
  ASSERT( subst != NULL );
  substitutions.push_back( Substitution( v, subst ) );
  m_positions.resize( substitutions.size() );
}

const Variable* OperationVariableSubstitution::GetVar( size_t index ) const
{
  ASSERT( index < GetCount() );
  return substitutions[index].first;
}

const Term* OperationVariableSubstitution::GetSubst( size_t index ) const
{
  ASSERT( index < GetCount() );
  return substitutions[index].second;
}

const NodePointers&
OperationVariableSubstitution::GetPositions( size_t index ) const
{
  ASSERT( index < substitutions.size() );
  ASSERT( index < m_positions.size() );

  return m_positions[index];
}

DECLARE_APPLY_FUNCTION_HEAD( Variable, Term, OperationVariableSubstitution, v )
{
#if 0
  if( v != this->v )
    return v;

  return (Term*) t;
#endif
  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( v != substitutions[i].first )
      continue; // not "this" variable

    if( bounded.FindTerm( substitutions[i].first ) >= 0 )
      continue; // variable is bounded

    m_positions[i].Add( m_np );
    return (Term*) substitutions[i].second;
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationVariableSubstitution, f )
{
  // don't replace bounded vars!
  bounded.AddRight( f->GetVariable() );
#if 0
  if( v == f->GetVariable() )
   return f;
#endif

  ProofLib::Formula *f_1 = ExpressionOperation::ApplyToQuantorFormula( f );

  ASSERT( bounded.GetTerm( bounded.GetChildCount() - 1 ) == f->GetVariable() );
  bounded.RemoveAt( bounded.GetChildCount() - 1 );

  return f_1;
}

std::ostream& OperationVariableSubstitution::ToString( std::ostream &out ) const
{
  typedef std::pair< const Variable*, const Term* > Substitution;

  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( i != 0 ) out << ", ";
    substitutions[i].first->ToString(out);
    out << " <- ";
    substitutions[i].second->ToString(out);
  }

  return out;
}

////////////////////////////////////////////////////////////////////////////////

OperationTermSubstitution::OperationTermSubstitution(
  NodeDatabase *ndb, const Term *t, const Term *subst,
  const NodePointers* positions_allowed )
{
  ASSERT( ndb != NULL );
//  m_ndb = pdb->GetNodeDatabase();
//  m_pdb = pdb;
  m_ndb = ndb;

  this->t = t;
  this->subst = subst;

  m_positions_allowed = positions_allowed;
}

void OperationTermSubstitution::Push( size_t index )
{
  m_np.Push( index );
}

size_t OperationTermSubstitution::Pop()
{
  return m_np.Pop();
}

DECLARE_APPLY_FUNCTION_HEAD( Variable, Term, OperationTermSubstitution, v )
{
  if( m_positions_allowed != NULL && !m_positions_allowed->IsAboveAny( m_np ) )
    return v;

  if( v == t )
  {
    m_positions.Add( m_np );
    return (Term*) subst;
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD( Constant, Term, OperationTermSubstitution, c )
{
  if( m_positions_allowed != NULL && !m_positions_allowed->IsAboveAny( m_np ) )
    return c;

  if( c == t )
  {
    m_positions.Add( m_np );
    return (Term*) subst;
  }

  return c;
}

DECLARE_APPLY_FUNCTION_HEAD( Function, Term, OperationTermSubstitution, f )
{
  if( m_positions_allowed != NULL && !m_positions_allowed->IsAboveAny( m_np ) )
    return f;

  if( f == t )
  {
    m_positions.Add( m_np );
    return (Term*) subst;
  }

  return ExpressionOperation::ApplyToFunction( f );
}

////////////////////////////////////////////////////////////////////////////////
const Term* VariableSubstitution::GetSubstFor( const Variable *v ) const
{
  for( size_t i = 0; i < GetCount(); i++ )
  {
    if( GetVar(i) == v )
      return GetSubst(i);
  }

  return NULL;
}

////////////////////////////////////////////////////////////////////////////////
const AbstractTerm* AllVariableSubstitution::GetSubstFor( const AbstractTerm *v ) const
{
  const SecondOrderVariable *v1 = dynamic_cast<const SecondOrderVariable*>( v );
  const Variable *v2 = dynamic_cast<const Variable*>( v );
  ASSERT( v1 != NULL || v2 != NULL );

  for( size_t i = 0; i < GetCount(); i++ )
  {
    if( GetVar(i) == v )
      return GetSubst(i);
  }

  return NULL;
}
////////////////////////////////////////////////////////////////////////////////

bool OperationMGUSimple::Unify( const DataNode *left, const DataNode *right )
{
  return left->ApplyCompare( *this, right );
}

std::ostream& OperationMGUSimple::ToString( std::ostream &out ) const
{
  UnificationTable::const_iterator i;

  for( i = m_table.begin(); i != m_table.end(); i++ )
  {
    if( i != m_table.begin() )
      out << ",";

    i->first->ToString(out);
    out << " == ";
    i->second->ToString(out);
  }

  return out;
}

bool OperationMGUSimple::AddSubstition( Side s, const Variable *v, const Term *t )
{
  ASSERT( v != NULL );
  ASSERT( t != NULL );

  const Term* subst = GetSubstFor(v);

  OperationVariableSubstitution op( GetNodeDatabase(), *this );

  Term *t1 = DataNode::ApplyTo( (Term*) t, op );

  if( subst == t1 )
    return true;

  TermList check;
  OperationGetVariables op_oc( check );

  DataNode::ApplyTo( (Term*) t1, op_oc );

  if( check.FindTerm( v ) >= 0 )
    return false; // occur check!

  if( subst == NULL )
  {
    OperationVariableSubstitution op1( GetNodeDatabase() );
    op1.AddSubstitution( v, t1 );
    UnificationTable::iterator i;
    for( i = m_table.begin(); i != m_table.end(); i++ )
    {
      i->second = DataNode::ApplyTo( (Term*) i->second, op1 );
    }
    m_table.push_back( Unification( v, t1 ) );
    return true;
  }

  const Variable *subst_v = subst->CastTo<const Variable>();

  if( subst_v != NULL )
  {
    if( check.FindTerm( subst_v ) >= 0 )
      return false; // occur check!

    OperationVariableSubstitution op1( GetNodeDatabase() );
    op1.AddSubstitution( v, t1 );
    op1.AddSubstitution( subst_v, t1 );
    UnificationTable::iterator i;
    for( i = m_table.begin(); i != m_table.end(); i++ )
    {
      i->second = DataNode::ApplyTo( (Term*) i->second, op1 );
    }
    m_table.push_back( Unification( subst_v, t1 ) );
    return true;
  }

  return false;
}

const Variable* OperationMGUSimple::GetVar( size_t index ) const
{
  ASSERT( index < m_table.size() );
  return m_table[index].first;
}

const Term* OperationMGUSimple::GetSubst( size_t index ) const
{
  ASSERT( index < m_table.size() );
  return m_table[index].second;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD( Variable, OperationMGUSimple, t )
{
  const Term *o_t = o->CastTo<const Term>();
  return AddSubstition( Left, t, o_t );
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD( Constant, OperationMGUSimple, t )
{
  if( t == o )
    return true;

  const Variable *o_v = o->CastTo<const Variable>();
  
  if( o_v != NULL )
    return AddSubstition( Right, o_v, t );

  return false;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD( Function, OperationMGUSimple, t )
{
  ASSERT( t != NULL );
  ASSERT( o != NULL );

  const Function *f_o = o->CastTo<const Function>();

  if( f_o == NULL )
  {
    const Variable *o_v = o->CastTo<const Variable>();

    if( o_v != NULL )
      return AddSubstition( Right, o_v, t );

    return false;
  }

  if( !t->HaveEqualSymbol( f_o ) )
    return false;

  for( size_t i = 0; i < t->GetChildCount(); i++ )
  {
    Push(i);
    bool ret = t->GetTerm(i)->ApplyCompare( *this, f_o->GetTerm(i) );
    Pop();

    if( !ret )
      return false;
  }

  return true;
}

////////////////////////////////////////////////////////////////////////////////

FreshVarMap::FreshVarMap( FreshVariableGenerator *fg, const DataNode *node,
                          size_t start )
{
  ASSERT( fg != NULL );
  ASSERT( node != NULL );
  m_fg = fg;
  m_next_var_num = start;
  AddVarsFromNode( node );
}

FreshVarMap::~FreshVarMap()
{
  for( VarMapping::iterator i = m_map.begin(); i != m_map.end(); i++ )
  {
    i->first->Detach();
    i->second->Detach();
  }
}

void FreshVarMap::operator=( const FreshVarMap &o )
{
  for( VarMapping::iterator i = m_map.begin(); i != m_map.end(); i++ )
  {
    i->first->Detach();
    i->second->Detach();
  }

  m_map.clear();

  for( VarMapping::const_iterator i = o.m_map.begin(); i != o.m_map.end(); i++ )
  {
    i->first->Attach();
    i->second->Attach();

    m_map.push_back( VarMap( i->first, i->second ) );
  }

  m_fg = o.m_fg;
  m_next_var_num = o.m_next_var_num;
}

void FreshVarMap::AddVarsFromNode( const DataNode *node )
{
  ASSERT( node != NULL );

  TermList vars;
  OperationGetVariables getvars( vars );

  ((DataNode*) node)->Apply( getvars );
  
  for( size_t i = 0; i < vars.GetChildCount(); i++ )
  {
    Variable* v = vars.GetTerm(i)->CastTo<Variable>();
    v->Attach();
    Variable* w = m_fg->GetVariableNum( m_next_var_num++ );
    w->Attach();
    m_map.push_back( VarMap( v, w ) );
  }
}

const Variable* FreshVarMap::GetVar( size_t index ) const
{
  ASSERT( index < m_map.size() );
  return m_map[index].first;
}

const Variable* FreshVarMap::GetSubst( size_t index ) const
{
  ASSERT( index < m_map.size() );
  return m_map[index].second;
}

////////////////////////////////////////////////////////////////////////////////

OperationMGU::UnificationTable::~UnificationTable()
{
  for( size_t i = 0; i < size(); i++ )
  {
    (*this)[i].first->Detach();
    (*this)[i].second->Detach();
  }
}

void OperationMGU::UnificationTable::operator=( const UnificationTable &o )
{
  for( size_t i = 0; i < size(); i++ )
  {
    (*this)[i].first->Detach();
    (*this)[i].second->Detach();
  }

  clear();

  for( size_t i = 0; i < o.size(); i++ )
  {
    AddSubstitution( o[i].first, o[i].second );
  }
}

void OperationMGU::UnificationTable::
AddSubstitution( const Variable* v_, const Term* t_ )
{
  Variable *v = (Variable*) v_;
  Term *t = (Term*) t_;
  
  v->Attach();
  t->Attach();

  push_back( Unification( v, t ) );
}

void OperationMGU::UnificationTable::ApplyOperation( ExpressionOperation &op )
{
  UnificationTable::iterator i;
  for( i = begin(); i != end(); i++ )
  {
    Term *t = i->second;
    i->second = DataNode::ApplyTo( i->second, op );

    if( t != i->second )
    {
      i->second->Attach();
      t->Detach();
    }
  }
}

const Variable* OperationMGU::UnificationTable::GetVar( size_t index ) const
{
  ASSERT( index < GetCount() );
  return (*this)[index].first;
}

const Term* OperationMGU::UnificationTable::GetSubst( size_t index ) const
{
  ASSERT( index < GetCount() );
  return (*this)[index].second;
}

std::ostream&
OperationMGU::UnificationTable::ToString( std::ostream &out ) const
{
  const_iterator i;

  for( i = begin(); i != end(); i++ )
  {
    if( i != begin() )
      out << ",";

    i->first->ToString(out);
    out << " == ";
    i->second->ToString(out);
  }

  return out;
}

OperationMGU::OperationMGU( FreshVariableGenerator *fg,
                            const FreshVarMap *m1, const FreshVarMap *m2 )
{
  m_fg = fg;
  m_new_var_count = 0;
  m_map_l = m1;
  m_map_r = m2;
}

/*
void OperationMGU::operator=( const OperationMGU &o )
{
   m_tabla = o.m_tablee;

  const FreshVarMap *m_map_l;
  const FreshVarMap *m_map_r;

  size_t m_new_var_count;

  FreshVariableGenerator *m_fg;
}
*/

bool OperationMGU::Unify( const DataNode *left, const DataNode *right )
{
  return left->ApplyCompare( *this, right );
}

std::ostream& OperationMGU::ToString( std::ostream &out ) const
{
#if 0
  UnificationTable::const_iterator i;

  for( i = m_table.begin(); i != m_table.end(); i++ )
  {
    if( i != m_table.begin() )
      out << ",";

    i->first->ToString(out);
    out << " == ";
    i->second->ToString(out);
  }
#endif
//  m_table.ToString(out);

  bool left = true;

  while( true )
  {
    out << ( left ? "left" : " right" ) << ": ";
    
    const FreshVarMap *map = ( left ? m_map_l : m_map_r );
    
    for( size_t i = 0; i < map->GetCount(); i++ )
    {
      if( i != 0 ) out << ", ";
      map->GetVar(i)->ToString(out);
      out << " <- ";
      const Term *t = m_table.GetSubstFor( map->GetSubst(i) );
      if( t == NULL )
        map->GetSubst(i)->ToString(out);
      else
        t->ToString(out);
    }

    if( left ) left = false; else break;
  }

  return out;
}

void
OperationMGU::GetSubstitution( Side s, OperationVariableSubstitution &op ) const
{
  const FreshVarMap *map = ( s == Left ? m_map_l : m_map_r );

  for( size_t i = 0; i < map->GetCount(); i++ )
  {
    const Term *t = m_table.GetSubstFor( map->GetSubst(i) );
    if( t == NULL ) t = map->GetSubst(i);
    op.AddSubstitution( map->GetVar(i), t );
  }
}

const Variable* OperationMGU::MapVar( Side s, const Variable *v )
{
  ASSERT( v != NULL );

  const FreshVarMap *map = ( s == Left ? m_map_l : m_map_r );

#if 1
  if( map->GetSubstFor(v) == NULL )
  {
    std::cerr << "Missing map on " << ( s == Left ? "left" : "right" )
              << " side for var ";
    v->ToString(std::cerr) << "." << std::endl;
  }
#endif
  return map->GetSubstFor(v)->CastTo<const Variable>();
#if 0
  for( size_t i = 0; i < map.size(); i++ )
  {
    if( map[i].first == v )
      return map[i].second;
  }
  
  Variable* w = m_fg->GetVariableNum( m_new_var_count++ );
  w->Attach(); // TODO Detach sometime !!!
  ASSERT( w != NULL );
  map.push_back( VarMap( v, w ) );
  return w;
#endif
}

bool OperationMGU::AddSubstition( Side s, const Variable *v, const Term *t )
{
  ASSERT( v != NULL );
  ASSERT( t != NULL );

  v = MapVar( s, v );

  TermList list;
  OperationGetVariables getVars( list );
  ((Term*) t)->Apply( getVars );

  OperationVariableSubstitution vs( GetNodeDatabase() );

  for( size_t i = 0; i < list.GetChildCount(); i++ )
  {
    Variable *u = list.GetTerm(i)->CastTo<Variable>();
    ASSERT( u != NULL );

    vs.AddSubstitution( u, MapVar( ( s == Left ? Right : Left ), u ) );
  }

  Term *u = DataNode::ApplyTo( (Term*) t, vs );
  u->Attach();
  
  bool ok = AddSubstition( v, u );
  
  u->Detach();

  return ok;
}

bool OperationMGU::AddSubstition( const Variable *v, const Term *t )
{
  ASSERT( v != NULL );
  ASSERT( t != NULL );

  const Term* subst = m_table.GetSubstFor(v);

  OperationVariableSubstitution op( GetNodeDatabase(), m_table );

  Term *t1 = DataNode::ApplyTo( (Term*) t, op );

  if( subst == t1 )
    return true;

  TermList check;
  OperationGetVariables op_oc( check );

  DataNode::ApplyTo( (Term*) t1, op_oc );

  if( check.FindTerm( v ) >= 0 )
    return false; // occur check!

  if( subst == NULL )
  {
    OperationVariableSubstitution op1( GetNodeDatabase() );
    op1.AddSubstitution( v, t1 );
    m_table.ApplyOperation( op1 );
    m_table.AddSubstitution( v, t1 );
#if 0
    UnificationTable::iterator i;
    for( i = m_table.begin(); i != m_table.end(); i++ )
    {
      i->second = DataNode::ApplyTo( (Term*) i->second, op1 );
    }
    m_table.push_back( Unification( v, t1 ) );
#endif
    return true;
  }

  const Variable *subst_v = subst->CastTo<const Variable>();

  if( subst_v != NULL )
  {
    if( check.FindTerm( subst_v ) >= 0 )
      return false; // occur check!

    OperationVariableSubstitution op1( GetNodeDatabase() );
    op1.AddSubstitution( v, t1 );
    op1.AddSubstitution( subst_v, t1 );
    m_table.ApplyOperation( op1 );
    m_table.AddSubstitution( subst_v, t1 );
#if 0
    UnificationTable::iterator i;
    for( i = m_table.begin(); i != m_table.end(); i++ )
    {
      i->second = DataNode::ApplyTo( (Term*) i->second, op1 );
    }
    m_table.push_back( Unification( subst_v, t1 ) );
#endif
    return true;
  }

  return false;
}

void OperationMGU::Finalize()
{
  m_map_l = new FreshVarMap( *m_map_l );
  m_map_r = new FreshVarMap( *m_map_r );
}

#if 0
const Variable* OperationMGU::GetVar( size_t index ) const
{
  ASSERT( index < m_table.GetCount() );
  return m_table.GetVar(index);
}

const Term* OperationMGU::GetSubst( size_t index ) const
{
  ASSERT( index < m_table.GetCount() );
  return m_table.GetSubst(index);
}
#endif

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD( Variable, OperationMGU, t )
{
  const Term *o_t = o->CastTo<const Term>();
  return AddSubstition( Left, t, o_t );
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD( Constant, OperationMGU, t )
{
  if( t == o )
    return true;

  const Variable *o_v = o->CastTo<const Variable>();
  
  if( o_v != NULL )
    return AddSubstition( Right, o_v, t );

  return false;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD( Function, OperationMGU, t )
{
  ASSERT( t != NULL );
  ASSERT( o != NULL );

  const Variable *o_v = o->CastTo<const Variable>();

  if( o_v != NULL )
    return AddSubstition( Right, o_v, t );

#if 0
  if( !t->HaveEqualSymbol( f_o ) )
    return false;

  for( size_t i = 0; i < t->GetChildCount(); i++ )
  {
    Push(i);
    bool ret = t->GetTerm(i)->ApplyCompare( *this, f_o->GetTerm(i) );
    Pop();

    if( !ret )
      return false;
  }
#endif

  return ApplyToFunction( t, o );
}

////////////////////////////////////////////////////////////////////////////////

Substitution::Substitution()
{
  var = NULL;
  by = NULL;
}

Substitution::Substitution( const Variable *v, const Term *r )
{
  ASSERT( v != NULL );
  ASSERT( r != NULL );

  var = (Variable*) v;
  by = (Term*) r;

  var->Attach();
  by->Attach();
}

Substitution::Substitution( const Substitution &o )
{
  (*this) = o;
}

Substitution::~Substitution()
{
  if( var != NULL )
    var->Detach();
  if( by != NULL )
    by->Detach();
}

void Substitution::operator=( const Substitution &o )
{
  var = o.var;
  by = o.by;

  if( var != NULL )
    var->Attach();
  if( by != NULL )
    by->Attach();
}

std::ostream& Substitution::ToString( std::ostream &out ) const
{
  if( var == NULL )
  {
    out << "(empty substitution)";
    return out;
  }

  ASSERT( by != NULL );

  var->ToString(out);
  out << " <-- ";
  by->ToString(out);

  return out;
}

////////////////////////////////////////////////////////////////////////////////

const Term* Substitutions::GetReplacementFor( const Variable *var ) const
{
  for( size_t i = 0; i < size(); i++ )
  {
    if( (*this)[i].GetVar() == var )
      return (*this)[i].GetSubst();
  }

  return NULL;
}

bool Substitutions::CheckSubstitution( const Variable *var, const Term *rep )
{
  const Term *ex = GetReplacementFor( var );

  if( ex == NULL )
  {
    push_back( Substitution( var, rep ) );
    return true;
  }

  if( ex == rep )
    return true;

  return false;
}

// subset of s?
bool Substitutions::operator < ( const Substitutions &s ) const
{
  if( size() > s.size() )
    return false;

  for( size_t i = 0; i < size(); i++ )
    if( (*this)[i].GetSubst() != s.GetReplacementFor( (*this)[i].GetVar() ) )
      return false;

  return true;
}

std::ostream& Substitutions::ToString( std::ostream &out ) const
{
  for( size_t i = 0; i < size(); i++ )
  {
    (*this)[i].ToString( out );
    out << std::endl;
  }

  return out;
}

////////////////////////////////////////////////////////////////////////////////

void SubstPossibilities::Add( const Substitutions &s )
{
  for( size_t i = 0; i < size(); i++ )
  {
    if( s < (*this)[i] )
      return; // s is a subset of an already existing subst
    if( (*this)[i] < s )
    {
      (*this)[i] = s; // s is a super set of an ex subst.
      return;
    }
  }

  push_back( s );
}

bool SubstPossibilities::Merge( const SubstPossibilities &o )
{
  SubstPossibilities ex( *this );

  bool was_empty = empty();

  clear();

  for( size_t i = 0; i < o.size(); i++ )
  {
    if( ex.empty() )
    {
      push_back( o[i] );
      continue;
    }

    for( size_t j = 0; j < ex.size(); j++ )
    {
      Substitutions s( ex[j] );

      bool failed = false;

      for( size_t k = 0; k < o[i].size(); k++ )
      {
        if( !s.CheckSubstitution( o[i][k].GetVar(), o[i][k].GetSubst() ) )
        {
          failed = true;
          break;
        }
      }

      if( !failed )
      {
        push_back( s );
      }
    }
  }
  
  return was_empty || !empty();
}

std::ostream& SubstPossibilities::ToString( std::ostream &out ) const
{
  for( size_t i = 0; i < size(); i++ )
  {
    out << i << "." << std::endl;
    (*this)[i].ToString( out );
  }

  return out;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( AtomFormula, Formula, OperationReplaceTerm, f )
{
  AbstractTermList *tl = new AbstractTermList();
  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
  	Push(i + 1);
	OperationReplaceTerm op_rep( m_ndb, replacement, position, np );
	AbstractTerm *t = DataNode::ApplyTo( f->GetTerm( i ), op_rep );
        tl->AddRight( t );
  	Pop();
  }

  AtomFormula *new_f = AtomFormula::New( m_ndb, f->GetSymbol(), tl, f->GetSecondOrderVariable() );

  return ExpressionOperation::ApplyToAtomFormula( new_f );
}

DECLARE_APPLY_FUNCTION_HEAD
  ( DefinedSetFormula, Formula, OperationReplaceTerm, f )
{
  Push(0);
  DefinedSet *new_s = DataNode::ApplyTo( f->getDefinedSet(), *this );
  Pop();

  TermList *tl = new TermList();
  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
  	Push(i);
	OperationReplaceTerm op_rep( m_ndb, replacement, position, np );
	Term *t = DataNode::ApplyTo( f->GetTerm( i ), op_rep );
        tl->AddRight( t );
  	Pop();
  }

  DefinedSetFormula *new_f = DefinedSetFormula::New( m_ndb, new_s, tl );

  return ExpressionOperation::ApplyToDefinedSetFormula( new_f );
}

////////////////////////////////////////////////////////////////////////////////

DECLARE_APPLY_FUNCTION_HEAD ( AtomFormula, Formula, OperationGetTerms, f )
{
#if 0
  std::cerr << "getting terms of formula ";
  HLK::Print::PrintFormula( f, std::cerr );
  std::cerr << std::endl;
#endif

  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
    // FIXME: do not cast!
    Term *t = dynamic_cast<Term*>( f->GetTerm( i ) );
    if ( t != NULL )
    {
      list.AddRight( t );
      np.Push( i  + 1 );
      nps.Add( np );
      np.Pop();
    }
  }

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD ( DefinedSetFormula, Formula, OperationGetTerms, f )
{
#if 0
  std::cerr << "getting terms of formula ";
  HLK::Print::PrintFormula( f, std::cerr );
  std::cerr << std::endl;
#endif

  Push( 0 );
  ApplyToDefinedSet( f->getDefinedSet() );
  Pop();

  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
    // FIXME: do not cast!
    list.AddRight( dynamic_cast<Term*>( f->GetTerm( i ) ) );
    np.Push( i  + 1 );
    nps.Add( np );
//    OperationGetSubterms op_sub( list, nps, np );
//    DataNode::ApplyTo( f->GetTerm( i ), op_sub );
    np.Pop();
  }

  return f;
}

DECLARE_APPLY_FUNCTION_HEAD ( DefinedSet, SetTerm, OperationGetTerms, f )
{
#if 0
  std::cerr << "getting terms of definedset ";
  HLK::Print::PrintFormula( f, std::cerr );
  std::cerr << std::endl;
#endif

  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
    // FIXME: do not cast!
    Term *t = dynamic_cast<Term*>( f->GetTerm( i ) );
    if ( t != NULL )
    {
      list.AddRight( t );
      np.Push( i  + 1 );
      nps.Add( np );
      np.Pop();
    }
  }

  return f;
}

////////////////////////////////////////////////////////////////////////////////

OperationLambdaSubstitution::OperationLambdaSubstitution(
  ProofDatabase *pdb, const SecondOrderVariable *v, const LambdaTerm *subst )
{
  ASSERT( pdb != NULL );
  m_ndb = pdb->GetNodeDatabase();
  m_pdb = pdb;

  AddSubstitution( v, subst );
}

OperationLambdaSubstitution::OperationLambdaSubstitution(
  NodeDatabase *ndb, const SecondOrderVariable *v, const LambdaTerm *subst )
{
  ASSERT( ndb != NULL );
  m_ndb = ndb;
  m_pdb = NULL;

  AddSubstitution( v, subst );
}

OperationLambdaSubstitution::OperationLambdaSubstitution(
  NodeDatabase *ndb )
{
  ASSERT( ndb != NULL );
  m_ndb = ndb;
  m_pdb = NULL;
}

void OperationLambdaSubstitution::AddSubstitution(
  const SecondOrderVariable *v, const LambdaTerm *subst )
{
  ASSERT( v != NULL );
  ASSERT( subst != NULL );

  substitutions.push_back( Substitution( v, subst ) );
  m_positions.resize( substitutions.size() );
}

const SecondOrderVariable* OperationLambdaSubstitution::GetVar( size_t index ) const
{
  ASSERT( index < GetCount() );
  return substitutions[index].first;
}

const LambdaTerm* OperationLambdaSubstitution::GetSubst( size_t index ) const
{
  ASSERT( index < GetCount() );
  return substitutions[index].second;
}

const NodePointers&
OperationLambdaSubstitution::GetPositions( size_t index ) const
{
  ASSERT( index < substitutions.size() );
  ASSERT( index < m_positions.size() );

  return m_positions[index];
}

DECLARE_APPLY_FUNCTION_HEAD( SecondOrderVariable, SetTerm, OperationLambdaSubstitution, v )
{
  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( v != substitutions[i].first )
      continue; // not "this" variable

    if( std::find( bounded.begin(), bounded.end(), substitutions[i].first ) != bounded.end() )
      continue; // variable is bounded

    m_positions[i].Add( m_np );
   
    // FIXME: const_cast 
    return const_cast<LambdaTerm*>( substitutions[i].second );
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD( AtomFormula, Formula, OperationLambdaSubstitution, v )
{
  if ( v->GetSecondOrderVariable() == NULL )
  {
    AbstractTermList tl;
    // recurse!
    bool changed = false;
    for ( size_t i = 0; i < v->GetChildCount(); i++ )
    {
      Push( i );
      AbstractTerm *t = DataNode::ApplyTo( v->GetTerm( i ), *this );
      Pop();
      tl.AddRight( t );
      if ( t != v->GetTerm( i ) )
	changed = true;
    }

    if (!changed)
      return v;

    return AtomFormula::New( m_ndb, v->GetSymbol(), &tl, v->GetSecondOrderVariable() );
  }

  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( v->GetSecondOrderVariable() != substitutions[i].first )
      continue; // not "this" variable

    if( std::find( bounded.begin(), bounded.end(), substitutions[i].first ) != bounded.end() )
      continue; // variable is bounded

    m_positions[i].Add( m_np );
    
    TermList tl;
    for ( unsigned int j = 0; j < v->GetChildCount(); j++)
    {
      // FIXME: do not cast
      tl.AddRight( dynamic_cast<Term*>( v->GetTerm( j ) ) );
    }
    
    return substitutions[i].second->apply( m_pdb, tl );
  }

  return v;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SecondOrderQuantorFormula, Formula, OperationLambdaSubstitution, f )
{
  // don't replace bounded vars!
  bounded.push_back( f->GetSecondOrderVariable() );
#if 0
  if( v == f->GetVariable() )
   return f;
#endif

  ProofLib::Formula *f_1 = ExpressionOperation::ApplyToSecondOrderQuantorFormula( f );

  ASSERT( bounded.back() == f->GetSecondOrderVariable() );
  bounded.pop_back();

  return f_1;
}

std::ostream& OperationLambdaSubstitution::ToString( std::ostream &out ) const
{
  typedef std::pair< const SecondOrderVariable*, const SecondOrderVariable* > Substitution;

  for( size_t i = 0; i < substitutions.size(); i++ )
  {
    if( i != 0 ) out << ", ";
    substitutions[i].first->ToString(out);
    out << " <- ";
    substitutions[i].second->ToString(out);
  }

  return out;
}

////////////////////////////////////////////////////////////////////////////////

std::ostream& OperationGetSecondOrderVariableSubstitutions::ToString( std::ostream &out ) const
{
  for( size_t i = 0; i < vars.size(); i++ )
  {
//    if( i != 0 ) out << std::endl;
//    HLK::Print::PrintAbstractTerm( vars[ i ], out );
//    out << " <- ";
//    HLK::Print::PrintAbstractTerm( reps[ i ], out );
  }

  return out;
}

Variable* 
OperationGetSecondOrderVariableSubstitutions::getNormalVariable( size_t index, USTRING type_name )
{
  ASSERT( false );
  return NULL;
#if 0
  if ( index >= normal_variables.size() )
  {
  	for ( size_t i = normal_variables.size(); i <= index; i++)
    {
  	  normal_variables.push_back( NULL );
    }
  }
  
  if ( normal_variables[ index ] == NULL )
  {  
    // FIXME: get sourcelocation from somewhere else?
    SourceLocation sloc( "___INTERNAL_OperationGetLambdaSubstitutions___",
                          0, 0);
     
    
    const HLK::VariableSymbol* vs = m_symtbl->NewVariable(
        USTRING(),
        type_name,
        true,
        sloc );
    Variable* new_v = Variable::New( m_ndb, vs );
    normal_variables[ index ] = new_v;
  }
  
  return normal_variables[ index ];
#endif
}

void OperationGetSecondOrderVariableSubstitutions::Clear()
{
  while( vars.size() > 0 ) vars.clear();
  while( reps.size() > 0 ) reps.clear();
  while( bounded.size() > 0 ) bounded.clear();
//  while( equals.GetChildCount() > 0 ) equals.RemoveAt(0);
  pos.clear();
  np.Clear();
}

bool OperationGetSecondOrderVariableSubstitutions::CheckForSubstitutions(
  DataNode *general, DataNode *instance )
{
  Clear();
  return general->ApplyCompare( *this, instance );
}

const SecondOrderVariable* OperationGetSecondOrderVariableSubstitutions::GetVar( size_t index ) const
{
  ASSERT( index < GetCount() );
  return vars[index];
}

const LambdaTerm* OperationGetSecondOrderVariableSubstitutions::GetSubst( size_t index ) const
{
  ASSERT( index < GetCount() );
  return reps[index];
}

const NodePointer& OperationGetSecondOrderVariableSubstitutions::GetVarPos( size_t index ) const
{
  ASSERT( index < GetCount() );
  return pos[index].var;
}

const NodePointers&
OperationGetSecondOrderVariableSubstitutions::GetSubstPos( size_t index ) const
{
  ASSERT( index < GetCount() );
  return pos[index].substs;
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( SecondOrderVariable, OperationGetSecondOrderVariableSubstitutions, v )
{
  ASSERT( false );
  return NULL;
#if 0
  std::cerr << "entered OperationGetSecondOrderVariableSubstitutions:ApplyToSecondOrderVariable" << std::endl;
  const SecondOrderVariable *o_v = dynamic_cast<const SecondOrderVariable*>( o );

  if ( o_v == NULL )
    return false;

  // variable already found?
  int p = -1;
  for (unsigned int i = 0; i < vars.size(); i++)
  {
//    std::cerr << "comparing ";
//    HLK::Print::PrintAbstractTerm( vars[i], std::cerr );
//    std::cerr << " and ";
//    HLK::Print::PrintAbstractTerm( o_v, std::cerr );
//    std::cerr << std::endl;

  	if ( vars[i] == v )
  	  p = i;
  }

  if ( p >= 0 )
  {
    // FIXME: check whether substitution matches!
    return true;
  }

//  std::cerr << "creating substitution term for ";
//  HLK::Print::PrintAbstractTerm( v, std::cerr );
//  std::cerr << ", ";
//  HLK::Print::PrintAbstractTerm( o_v, std::cerr );
 // std::cerr << std::endl;

  // FIXME: const cast!
  vars.push_back( const_cast<SecondOrderVariable*>( v ) );

  const HLK::PredicateSymbol *s = dynamic_cast<const HLK::PredicateSymbol*>( o_v->GetSymbol() );
  ASSERT( s != NULL );

  AbstractTermList b_vars1;
  TermList b_vars2;
  for ( size_t i = 0; i < s->GetArity(); i++ )
  {
    USTRING type_name = s->GetArgType( i )->GetName();
    Variable* new_v = getNormalVariable( i, type_name ); 
    b_vars1.AddRight( new_v );
    b_vars2.AddRight( new_v );
  }

  // FIXME: const cast!
  AtomFormula *f = AtomFormula::New( m_ndb, s, &b_vars1, const_cast<SecondOrderVariable*>( o_v ) );
  LambdaTerm *t = LambdaTerm::New( m_ndb, b_vars2, f );

  reps.push_back( t );

  return true;
#endif
}


DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( AtomFormula, OperationGetSecondOrderVariableSubstitutions, f )
{
  ASSERT( false );
  return NULL;
#if 0
  if ( f == o )
  {
  	// atoms are equal
    return true;
  }

  const AtomFormula *af = o->CastTo<const AtomFormula>();
 
  if( af == NULL )
  {
  	// datanode is not an AtomFormula, so we can't match
  	// by substituting variables
    return false;
  }

  // if both have the same symbol, we continue matching the arguments

  std::cerr << "comparing symbols" << std::endl;
  if ( af->GetSymbol() == f->GetSymbol() )
  {
    std::cerr << "symbols equal, comparing children" << std::endl;
    for ( size_t i = 0; i < af->GetChildCount(); i++ )
    {
      AbstractTerm *t_1 = f->GetTerm( i );
      AbstractTerm *t_2 = af->GetTerm( i );

      if (!t_1->ApplyCompare( *this, t_2 ))
	return false;
    }

    return true;
  }

  SecondOrderVariable *var = af->GetSecondOrderVariable();
  
  if ( var == NULL )
  {
  	// AtomFormula is constant, so we can't match by
  	// substituting variables
  	return false;
  }

  SecondOrderVariable *var2 = f->GetSecondOrderVariable();

  if ( var2 == NULL )
  {
  	// AtomFormula is constant, so this can't be the
  	// result of a variable substitution
  	return false;
  }

  // variable already found?
  int p = -1;
  for (unsigned int i = 0; i < vars.size(); i++)
  {
  	if ( vars[i] == var2 )
  	  p = i;
  }

  if( p >= 0 )
  {
  	TermList tl;
  	for ( unsigned int i = 0; i < f->GetChildCount(); i++ )
  	{
	  // FIXME: do not cast
  	  tl.AddRight( dynamic_cast<Term*>( f->GetTerm( i ) ) );	
  	}
    // variable has to be substituted with the same variable!
//#if 0
    std::cerr << "applying substitution: ";
    HLK::Print::PrintFormula( reps[p]->getFormula(), std::cerr );
    std::cerr << std::endl;
//#endif
    if( reps[p]->apply( m_pdb, tl ) != af )
      return false;

    pos[p].substs.Add( np );
    return true;
  }
  
  // was there already a position, where this var wasn't substituted?
  if( std::find( equals.begin(), equals.end(), var2 ) != equals.end() ) 
    return false;

  // is this a bounded variable?
  if( std::find( bounded.begin(), bounded.end(), var2 ) != bounded.end() ) 
    return true;

  p = pos.size();
  pos.resize( p + 1 );
  pos[p].var = np;
  pos[p].substs.Add( np );
  vars.push_back( var2 );
  
  // create lambda term representing this variable substitution
  // with an empty list of variables
  TermList b_vars;
  TermList *tl = new TermList();
  for ( unsigned int i = 0; i < af->GetChildCount(); i++)
  {
    // create new variables for lambda term
    // FIXME: do not cast!
    Term *t = dynamic_cast<Term*>( af->GetTerm(i) );
    USTRING type_name;
    Variable *v;
    Function *f;
    Constant *c;
     
    if ( (v = dynamic_cast<Variable*>(t)) != NULL )
    {
     const HLK::VariableSymbol* vs = dynamic_cast<const HLK::VariableSymbol*>(v->GetSymbol());
     ASSERT( vs != NULL );
     type_name = vs->GetType()->GetName();
    }
    else if ( (f = dynamic_cast<Function*>(t)) != NULL)
    {
      const HLK::FunctionSymbol* fs = dynamic_cast<const HLK::FunctionSymbol*>(f->GetSymbol());
      ASSERT( fs != NULL );
      type_name = fs->GetType()->GetName();
    }
    else if ( (c = dynamic_cast<Constant*>(t)) != NULL)
    {
      const HLK::ConstantSymbol* cs = dynamic_cast<const HLK::ConstantSymbol*>(c->GetSymbol());
      ASSERT( cs != NULL );
      type_name = cs->GetType()->GetName();
    }
    else
      ASSERT( false );
    
    
    Variable* new_v = getNormalVariable( i, type_name ); 
    tl->AddRight( new_v );
    new_v->Attach();
    b_vars.AddRight( new_v );
  }

  Formula *form = AtomFormula::New( m_ndb, af->GetSymbol(), tl, af->GetSecondOrderVariable() );
  LambdaTerm *t = LambdaTerm::New( m_ndb, b_vars, form );
//#if 0
  std::cerr << "Adding lambdaterm to reps: ";
  HLK::Print::PrintFormula( form, std::cerr );
  std::cerr << std::endl;
//#endif
  reps.push_back( t );

  return true;
#endif
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( SecondOrderQuantorFormula, OperationGetSecondOrderVariableSubstitutions, f )
{
  SecondOrderVariable *v = f->GetSecondOrderVariable();

  bool already = ( std::find( bounded.begin(), bounded.end(), v ) != bounded.end() );

  if( !already )
    bounded.push_back( v );

  bool ok = ExpressionCompareOperation::ApplyToSecondOrderQuantorFormula( f, o );

  if( !already )
  {
    std::vector<SecondOrderVariable*>::iterator pos = 
      std::find( bounded.begin(), bounded.end(), v );
    if ( pos != bounded.end() )
      bounded.erase( pos );
  }

  return ok;
}

////////////////////////////////////////////////////////////////////////////////

void OperationGetLambdaSubstitutions::Clear()
{
  while( vars.size() > 0 ) vars.clear();
  while( reps.size() > 0 ) reps.clear();
  while( bounded.size() > 0 ) bounded.clear();
//  while( equals.GetChildCount() > 0 ) equals.RemoveAt(0);
  pos.clear();
  np.Clear();
}

bool OperationGetLambdaSubstitutions::CheckForSubstitutions(
  DataNode *general, DataNode *instance )
{
  Clear();
  return general->ApplyCompare( *this, instance );
}

const SecondOrderVariable* OperationGetLambdaSubstitutions::GetVar( size_t index ) const
{
  ASSERT( index < GetCount() );
  return vars[index];
}

const std::set<LambdaTerm*> OperationGetLambdaSubstitutions::GetSubstSet( size_t index ) const
{
  ASSERT( index < GetCount() );
  return reps[index];
}

const LambdaTerm* OperationGetLambdaSubstitutions::GetSubst( size_t index ) const
{
  std::set<LambdaTerm*> substs = GetSubstSet( index );
  LambdaTerm *res = NULL;
  int varcount = -1;
  
  for ( std::set<LambdaTerm*>::iterator i = substs.begin();
        i != substs.end(); i++)
  {
  	// most general == most free variable occurences
  	TermList tl;
  	OperationCountFreeVariables op( tl );
  	(*i)->getFormula()->Apply( op );
  	int num = op.GetCount();

  	if ( num > varcount )
  	{
  	  varcount = num;
  	  res = *i;
  	}
  }
  
  ASSERT( res != NULL );
  
  return res;
}

const NodePointer& OperationGetLambdaSubstitutions::GetVarPos( size_t index ) const
{
  ASSERT( index < GetCount() );
  return pos[index].var;
}

const NodePointers&
OperationGetLambdaSubstitutions::GetSubstPos( size_t index ) const
{
  ASSERT( index < GetCount() );
  return pos[index].substs;
}

Variable* 
OperationGetLambdaSubstitutions::getNormalVariable( size_t index, USTRING type_name )
{
  ASSERT( false );
  return NULL;
#if 0
  if ( index >= normal_variables.size() )
  {
  	for ( size_t i = normal_variables.size(); i <= index; i++)
    {
  	  normal_variables.push_back( NULL );
    }
  }
  
  if ( normal_variables[ index ] == NULL )
  {  
    // FIXME: get sourcelocation from somewhere else?
    SourceLocation sloc( "___INTERNAL_OperationGetLambdaSubstitutions___",
                          0, 0);
     
    
    const HLK::VariableSymbol* vs = m_symtbl->NewVariable(
        USTRING(),
        type_name,
        true,
        sloc );
    Variable* new_v = Variable::New( m_ndb, vs );
    normal_variables[ index ] = new_v;
  }
  
  return normal_variables[ index ];
#endif
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( AtomFormula, OperationGetLambdaSubstitutions, f )
{
  ASSERT( false );
  return NULL;
#if 0
  if ( f == o )
  {
  	// atoms are equal
    return true;
  }

  SecondOrderVariable *var2 = f->GetSecondOrderVariable();

  if ( var2 == NULL )
  {
    // AtomFormula f is constant and not equal to af
    //
    // check symbols

    const AtomFormula *o_f = dynamic_cast<const AtomFormula*>( o );
    if ( o_f == NULL )
      return false;

    if ( f->GetSymbol() != o_f->GetSymbol() )
      return false;

    // unify arguments

    for ( size_t i = 0; i < f->GetChildCount(); i++ )
    {
      AbstractTerm *t_1 = f->GetTerm( i );
      AbstractTerm *t_2 = o_f->GetTerm( i );

      if (!t_1->ApplyCompare( *this, t_2 ))
	return false;
    }

    return true;
  }

  // collect terms appearing in formula, together with
  // a set of variables with size equal to the arity of
  // the variable atom formula

  TermList formula_terms;
  NodePointers formula_term_positions;
  OperationGetTerms op_gt( formula_terms, formula_term_positions );
  DataNode::ApplyTo( const_cast<DataNode*>(o), op_gt ) ;
//#if 0
  std::cerr << "formula_terms.GetChildCount() = " << formula_terms.GetChildCount() << std::endl;
  std::cerr << "formula_term_positions.GetCount() = " << formula_term_positions.GetCount() << std::endl;
//#endif
  TermList variables;
  for (unsigned int i = 0; i < f->GetChildCount(); i++)
  {
    // create new variables for lambda term
    // FIXME: do not cast
    Term *t = dynamic_cast<Term *>( f->GetTerm(i) );
    USTRING type_name;
    Variable *v;
    Function *f;
    Constant *c;
     
    if ( (v = dynamic_cast<Variable*>(t)) != NULL )
    {
     const HLK::VariableSymbol* vs = dynamic_cast<const HLK::VariableSymbol*>(v->GetSymbol());
     ASSERT( vs != NULL );
     type_name = vs->GetType()->GetName();
    }
    else if ( (f = dynamic_cast<Function*>(t)) != NULL)
    {
      const HLK::FunctionSymbol* fs = dynamic_cast<const HLK::FunctionSymbol*>(f->GetSymbol());
      ASSERT( fs != NULL );
      type_name = fs->GetType()->GetName();
    }
    else if ( (c = dynamic_cast<Constant*>(t)) != NULL)
    {
      const HLK::ConstantSymbol* cs = dynamic_cast<const HLK::ConstantSymbol*>(c->GetSymbol());
      ASSERT( cs != NULL );
      type_name = cs->GetType()->GetName();
    }
    else
      ASSERT( false );
    
    
    Variable* new_v = getNormalVariable( i, type_name ); 
    variables.AddRight( new_v );
  }

  TermList arguments;
  
  for ( size_t i = 0; i < f->GetChildCount(); i++ )
  {
    // FIXME: do not cast
  	arguments.AddRight( dynamic_cast<Term *>( f->GetTerm( i ) ) );
  }

  // create all permutations of terms and variables of
  // length equal to the arity of the variable atom formula

  const Formula *f2 = dynamic_cast<const Formula*>(o);
  
  ASSERT( f2 != NULL );
  
  permutations.clear();
  createPermutedFormulas( formula_term_positions,
                          //NodePointer(),
                          formula_terms,
                          variables,
                          arguments,
                          0,
                          const_cast<Formula*>(f2) );
 
  std::set<LambdaTerm*> lambda_terms;
  for ( size_t i = 0; i < permutations.size(); i++ )
  {
//#if 0
        std::cerr << "creating lambdaterm from permutation: ";
	HLK::Print::PrintFormula( permutations[i], std::cerr );
	std::cerr << std::endl;
//#endif
  	LambdaTerm *lt = LambdaTerm::New( m_ndb, variables, permutations[i] );
  	lambda_terms.insert( lt );
  }


  // variable already found?
  int p = -1;
  for (unsigned int i = 0; i < vars.size(); i++)
  {
    if ( vars[i] == var2 )
      p = i;
  }

  if( p >= 0 )
  {
    // intersect sets of lambda terms
    std::set<LambdaTerm*> new_lambda_terms;
    std::set_intersection(reps[p].begin(), reps[p].end(),
       lambda_terms.begin(), lambda_terms.end(),
       std::insert_iterator< std::set<LambdaTerm*> >(new_lambda_terms,
                                                     new_lambda_terms.begin() ) );
    reps[p] = new_lambda_terms;
    
    if ( reps[p].empty() )
    {
      return false;
    }

    return true;
  }
  
  // is this a bounded variable?
  if( std::find( bounded.begin(), bounded.end(), var2 ) != bounded.end() ) 
    return true;

  p = pos.size();
  pos.resize( p + 1 );
  pos[p].var = np;
  pos[p].substs.Add( np );
  vars.push_back( var2 );
  reps.resize( p + 1 );
  reps[p] = lambda_terms;

  if ( reps[p].empty() )
    return false;

  return true;
#endif
}

DECLARE_APPLY_FUNCTION_FOR_COMPARE_HEAD
  ( SecondOrderQuantorFormula, OperationGetLambdaSubstitutions, f )
{
  SecondOrderVariable *v = f->GetSecondOrderVariable();

  bool already = ( std::find( bounded.begin(), bounded.end(), v ) != bounded.end() );

  if( !already )
    bounded.push_back( v );

  bool ok = ExpressionCompareOperation::ApplyToSecondOrderQuantorFormula( f, o );

  if( !already )
  {
    std::vector<SecondOrderVariable*>::iterator pos = 
      std::find( bounded.begin(), bounded.end(), v );
    if ( pos != bounded.end() )
      bounded.erase( pos );
  }

  return ok;
}

void OperationGetLambdaSubstitutions::createPermutedFormulas( NodePointers &term_positions,
                                                              TermList &terms,
							      TermList &variables,
							      TermList &arguments,
							      size_t pos,
							      Formula *f )
{
  std::vector<Formula*>::iterator i;
  i = find( permutations.begin(), permutations.end(), f );
  if ( terms.GetChildCount() == 0  && i == permutations.end() )
  {
#if 0
    std::cerr << "Adding permutation: ";
    HLK::Print::PrintFormula( f, std::cerr );
    std::cerr << std::endl;
#endif
    permutations.push_back( f );
    return;
  }

  for ( size_t i = 0; i < terms.GetChildCount(); i++ )
  {
    Term *t = terms.GetTerm( i );
    NodePointer t_pos = term_positions[ i ];
#if 0
    std::cerr << "considering term ";
    HLK::Print::PrintTerm( t, std::cerr );
    std::cerr << " at pos ";
    t_pos.Dump( std::cerr ) ;
    std::cerr << std::endl;
#endif
    for ( size_t j = 0; j < arguments.GetChildCount(); j++ )
    {
      Term *arg = arguments.GetTerm( j );
#if 0
      std::cerr << "considering argument: ";
      HLK::Print::PrintTerm( arg, std::cerr );
      std::cerr << std::endl;
#endif
      if ( t == arg )
      {
#if 0
	std::cerr << "they are equal" << std::endl;
        std::cerr << "substituting ";
	HLK::Print::PrintTerm( variables.GetTerm( j ), std::cerr );
	std::cerr << " for term" << std::endl;
#endif
        OperationReplaceTerm op_rt( m_ndb, *(variables.GetTerm( j )), t_pos );
  	Formula *new_f = DataNode::ApplyTo( f, op_rt );
#if 0
        std::cerr << "new_f: ";
	HLK::Print::PrintFormula( new_f, std::cerr );
	std::cerr << std::endl;
#endif
	TermList newterms;
	NodePointers newpointers;
#if 0
        std::cerr << "new termlist: ";
#endif
	for ( size_t k = 0; k < terms.GetChildCount(); k++ )
	{
          if ( k != i )
	  {
#if 0
	    HLK::Print::PrintTerm( terms.GetTerm( k ), std::cerr );
	    std::cerr << ", ";
#endif
	    newterms.AddRight( terms.GetTerm( k ) ) ;
	    newpointers.Add( term_positions[ k ] ) ;
	  }
	}
#if 0
	std::cerr << std::endl;
#endif
	createPermutedFormulas( newpointers, newterms, variables, arguments, pos, new_f );
      }

      if ( blacklist.FindTerm( t ) == -1 )
      {
        TermList subterms;
        NodePointers subpointers;
        OperationGetSubterms op_sub( subterms, subpointers, t_pos );
        DataNode::ApplyTo( t, op_sub );
        createPermutedFormulas( subpointers, subterms, variables, arguments, pos, f );
      }
    }
  }
}

#if 0
void OperationGetLambdaSubstitutions::createPermutedFormulas( NodePointers &term_positions,
                                                              //NodePointer &current,
                                                              TermList &terms,
                                                              TermList &variables,
                                                              TermList &arguments,
                                                              size_t pos,
                                                              Formula *f )
{
  if ( term_positions.GetCount() - pos == 1)
  {
  	if ( blacklist.FindTerm( terms.GetTerm( pos ) ) == -1 )
  	{
  	  permutations.push_back( f );
  	}
  	for ( size_t i = 0; i < variables.GetChildCount(); i++ )
  	{
  	  if ( arguments.GetTerm( i ) == terms.GetTerm( pos ) )
  	  {
  	  	OperationReplaceTerm op_rt( m_ndb, *(variables.GetTerm( i )), term_positions[ pos ] );
  	  	Formula *new_f = DataNode::ApplyTo( f, op_rt );
  	  	permutations.push_back( new_f );
  	  }
  	}

  	return;
  }

  for ( size_t i = 0; i < variables.GetChildCount(); i++ )
  {
    if ( arguments.GetTerm( i ) == terms.GetTerm( pos ) )
  	{
  	  OperationReplaceTerm op_rt( m_ndb, *(variables.GetTerm( i )), term_positions[ pos ] );
  	  Formula *new_f = DataNode::ApplyTo( f, op_rt );

	  std::cerr << "new_f: " << std::endl;
	  HLK::Print::PrintFormula( new_f, std::cerr );

          createPermutedFormulas( term_positions, /*term_positions[ pos ],*/ terms, variables, arguments, pos+1, new_f );
  	}
  	if ( blacklist.FindTerm( terms.GetTerm( pos ) ) == -1 )
  	{
  	  createPermutedFormulas( term_positions, /*current,*/ terms, variables, arguments, pos+1, f );
  	}
  }
}
#endif

////////////////////////////////////////////////////////////////////////////////

OperationReplaceFormula::OperationReplaceFormula
  ( NodeDatabase *n, Formula *to_search, Formula *its_replacement )
{
  ASSERT( to_search != NULL );
  ASSERT( its_replacement != NULL );
  ASSERT( n != NULL );

  search = to_search;
  replacement = its_replacement;
  ndb = n;
}

ProofDatabase* OperationReplaceFormula::GetProofDatabase()
{
  ASSERT( false );
  return NULL;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( AtomFormula, Formula, OperationReplaceFormula, f )
{
  if( AtSequentScope() && f == search )
    return replacement;

  return ExpressionOperation::ApplyToAtomFormula( f );
}

DECLARE_APPLY_FUNCTION_HEAD
  ( UnaryConFormula, Formula, OperationReplaceFormula, f )
{
  if( AtSequentScope() && f == search )
    return replacement;

  return ExpressionOperation::ApplyToUnaryConFormula( f );
}

DECLARE_APPLY_FUNCTION_HEAD
  ( QuantorFormula, Formula, OperationReplaceFormula, f )
{
  if( AtSequentScope() && f == search )
    return replacement;

  return ExpressionOperation::ApplyToQuantorFormula( f );
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SecondOrderQuantorFormula, Formula, OperationReplaceFormula, f )
{
  if( AtSequentScope() && f == search )
    return replacement;

  return ExpressionOperation::ApplyToSecondOrderQuantorFormula( f );
}

DECLARE_APPLY_FUNCTION_HEAD
  ( BinaryConFormula, Formula, OperationReplaceFormula, f )
{
  if( AtSequentScope() && f == search )
    return replacement;

  return ExpressionOperation::ApplyToBinaryConFormula( f );
}

DECLARE_APPLY_FUNCTION_HEAD
  ( FormulaVariable, Formula, OperationReplaceFormula, f )
{
  if( AtSequentScope() && f == search )
    return replacement;

  return ExpressionOperation::ApplyToFormulaVariable( f );
}

////////////////////////////////////////////////////////////////////////////////

OperationReplaceFormulaSequence::
OperationReplaceFormulaSequence( NodeDatabase *ndb,
                                 const FormulaList *to_search,
                                 FormulaListElement *its_replacement )
{
  search = to_search;
  replacement = its_replacement;

  this->ndb = ndb;
}

ProofDatabase* OperationReplaceFormulaSequence::GetProofDatabase()
{
  ASSERT( false );
  return NULL;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( FormulaList, FormulaList, OperationReplaceFormulaSequence, l )
{
  return l;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SElementList, SElementList, OperationReplaceFormulaSequence, l )
{
  if( !InSequentScope() )
    return ExpressionOperation::ApplyToSElementList( l );

  size_t index = 0;

  while( l->FindSubListAtIndex( search, index ) )
  {
    Push( index );
    
    if( !AtSequentScope() )
    {
      Pop();
      continue;
    }
    
    for( size_t i = index + 1; i < search->GetChildCount() + index; i++ )
    {
      SElement *e = l->GetSElement(i);
      l->RemoveAt(i);
      delete e;
    }

    ProofLib::FormulaListVariable *fv =
      replacement->CastTo<ProofLib::FormulaListVariable>();

    if( fv != NULL )
      l->ReplaceSElement( index, new SFormulaListVariable( fv ) );
    else
      ASSERT( false );

    Pop();
    index++;
  }

  return l;
}
  
////////////////////////////////////////////////////////////////////////////////

OperationReplaceFormulaListElementBySequence::
OperationReplaceFormulaListElementBySequence( NodeDatabase *ndb,
                                   FormulaListElement *to_search,
                                   const FormulaList *its_replacement )
{
  search = to_search;
  replacement = its_replacement;

  this->ndb = ndb;
}

ProofDatabase* OperationReplaceFormulaListElementBySequence::GetProofDatabase()
{
  ASSERT( false );
  return NULL;
}

DECLARE_APPLY_FUNCTION_HEAD
  ( SElementList, SElementList,
    OperationReplaceFormulaListElementBySequence, l )
{
  if( !InSequentScope() )
    return l;

  for( size_t i = 0; i < l->GetChildCount(); i++ )
  {
    Push(i);

    if( !AtSequentScope() )
    {
      Pop();
      continue;
    }

    ProofLib::SFormulaListVariable *sfv =
      l->GetSElement(i)->CastTo<ProofLib::SFormulaListVariable>();

    if( sfv == NULL || sfv->GetFormulaListVariable() != search )
    {
      Pop();
      continue;
    }

    l->RemoveAt(i);
    l->InsertAt( i, replacement );

    Pop();
  }

  return l;
}

////////////////////////////////////////////////////////////////////////////////
}
