////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: util/fileexceptions.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _FILEEXCEPTIONS_H_
#define _FILEEXCEPTIONS_H_

#include <errno.h>
#include <string.h>

#include "util/exceptions.h"

class FileException : public Exception
{
};

class FileOpenFailException : public FileException
{
private:
  std::string            m_fn;
  int                    m_errnum;

public:
  FileOpenFailException( const char* filename, int errnum ) : m_fn( filename )
  {
    m_errnum = errnum;
  }
  virtual ~FileOpenFailException() {};

  virtual void Print( std::ostream &out ) const
  {
    out << "Unable to open file '" << m_fn << "': "
        << strerror( m_errnum ) << ".";
  }
};

#endif
