////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: util/hash.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _HASH_H_
#define _HASH_H_

#include <ext/hash_map>
#include <ext/hash_set>
#include <string.h>

#define stlhash __gnu_cxx

struct eqstr
{
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp(s1, s2) == 0;
  }
};

namespace stlhash
{
inline size_t __stl_hash_wstring(const wchar_t* __s)
{
  unsigned long __h = 0; 
  for ( ; *__s; ++__s)
    __h = 5*__h + *__s; // good?
  
  return size_t(__h);
}

template<> struct hash<wchar_t> {
  size_t operator()(wchar_t __x) const { return __x; }
};
template<> struct hash<std::wstring> {
  size_t operator()(std::wstring __x) const
    { return __stl_hash_wstring(__x.c_str()); }
};
template<> struct hash<std::string> {
  size_t operator()(std::string __x) const
    { return __stl_hash_string(__x.c_str()); }
};
}

#endif
