////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: util/proofexceptions.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _PROOFEXCEPTIONS_H_
#define _PROOFEXCEPTIONS_H_

#include "chars/chars.h"
#include "util/exceptions.h"

class ProofExistsException : public Exception
{
  USTRING               m_name;

public:
  ProofExistsException( const USTRING &name )
  {
    m_name = name;
  }

  virtual void Print( std::ostream &out ) const
  {
    std::string str;
    UTF8FromUString( m_name, str );
 
    out << "Proof \"" << str << "\" already exists.";
  }
};

class FormulaVarExistsException : public Exception
{
  USTRING               m_name;

public:
  FormulaVarExistsException( const USTRING &name )
  {
    m_name = name;
  }

  virtual void Print( std::ostream &out ) const
  {
    std::string str;
    UTF8FromUString( m_name, str );
 
    out << "Formula variable \"" << str << "\" already exists.";
  }
};

class FormulaListVarExistsException : public Exception
{
  USTRING               m_name;

public:
  FormulaListVarExistsException( const USTRING &name )
  {
    m_name = name;
  }

  virtual void Print( std::ostream &out ) const
  {
    std::string str;
    UTF8FromUString( m_name, str );
 
    out << "Formula list variable \"" << str << "\" already exists.";
  }
};

#endif
