////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: util/xmlread.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _XMLREAD_H_
#define _XMLREAD_H_

#include "chars/chars.h"

////////////////////////////////////////////////////////////////////////////////

class XmlReader
{
protected:
  XmlReader() {};
public:
  virtual ~XmlReader() {};

public:
  static XmlReader* New();

public:
  virtual void Open( const char *sourcename ) = 0;
  virtual void Close() = 0;

  virtual bool SeekToElement() = 0;
  virtual bool SeekToChildElement( size_t depth ) = 0;
  virtual bool SeekToNextElement( size_t depth ) = 0;
  virtual size_t CurrentDepth() = 0;
  virtual char* GetElementName() = 0;
  virtual void AssertCurrentElement( const char *name ) = 0;
  virtual USTRING GetAttribute( const char* attr_name, bool optional = false ) = 0;
  virtual char* GetCStrAttribute( const char* attr_name, bool optional = false ) = 0;

  virtual void ThrowMissingChildException( const char *name ) = 0;
  virtual void ThrowUnexpectedElement( const char *name ) = 0;

public:
  static void Init();
  static void AddCatalogSystemItem( const char *dtd_name,
                                    const char *file_name );
};

////////////////////////////////////////////////////////////////////////////////

#endif
