////////////////////////////////////////////////////////////////////////////////
//
// Proof Library for C++ -------------------------------------------------------
//
// File: util/xmlwrite.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _XMLWRITE_H
#define _XMLWRITE_H

//#include "data/chars.h"
#include "symboltable.h" // temp for USTRING

////////////////////////////////////////////////////////////////////////////////

class XmlWriter
{
protected:
  XmlWriter() {};

public:
  virtual ~XmlWriter() {}

  static XmlWriter* New();

public:
  virtual void Open( const char *sourcename ) = 0;
  virtual void Close() = 0;

  virtual void SetCompression( int level ) = 0;

  virtual void StartDocument( const char *xml_version, const char *enc ) = 0;
  virtual void EndDocument() = 0;
  virtual void WriteDTD( const char *root_node, const char *pub_id,
                         const char *sys_id, const char *subset ) = 0;
  virtual void OpenElement( const char *name ) = 0;
  virtual void CloseElement() = 0;
  virtual void WriteAttribute( const char *name, const char *value ) = 0;
  virtual void WriteAttribute( const char *name, const USTRING &value ) = 0;
};

////////////////////////////////////////////////////////////////////////////////

#endif
